UNIT OPLi386;

INTERFACE

USES
  OPT, OPM, OPOi386, OPL, _SYSTEM;

CONST
  rcld = 32;	rcldbdw = 64;	rcldwdw = 96;	rcldbw = 128;
	rcldbdwu = 160;	rcldwdwu = 196;	rcldbwu = 224;	rcgetReg = 256 ;
	rcputReg = 288;	rcldProc = 320;	rcldXProc = 352;	rclea = 384;
	rcstore = 416;	rcpush = 448;	rcpop = 480;	rcadd = 512;
	rcsub = 544;	rcmul = 576;	rcdiv = 608;	rcmod = 640;
	rcneg= 960;	rcabs = 992;	rccmp = 1056;	rcje = 1504;
	rcjne = 1536;	rcjl = 1568;	rcjle = 1600;	rcjg = 1632;
	rcjge = 1664;	rcja = 1696;	rcjae = 1728;	rcjb = 1760;
	rcjbe = 1792;	rcjc = 1824;	rcjnc = 1856;	rcjmp = 1888;
	rcjmpReg = 1920;	rcsete = 1120;	rcsetne = 1152;	rcsetl = 1184;
	rcsetle = 1216;	rcsetg = 1248;	rcsetge = 1280;	rcseta = 1312;
	rcsetae = 1344;	rcsetb = 1376;	rcsetbe = 1408;	rcsetc = 1440;
	rcsetnc = 1472;	rcte = 1952;	rctne = 1984;	rctle = 2944;
	rcta = 2016;	rctae = 2880;	rcto = 2912;
	rctrap = 2048;	rcor = 672;	rcxor = 704;	rcand = 736;
	rcnot = 1024;	rcbt = 1088;	rcbtr = 768;	rcbts = 800;	rctest = 3424;
	rccall = 2080;	rccallReg = 2112;	rcxcall = 2144;	rcret = 2176;
	rcenter = 2208;	rcleave = 2240;	rcsal = 832;	rcsar = 864;
	rcshr = 896;	rcrol = 928;	rccld = 2272;	rcrepMovs = 2304;
	rccmpString = 2336;	rcpushReg = 2368;	rcpopReg = 2400;	rccase = 2432;
	rcshort = 2976;	rcphi = 2464;	rclabel = 2496;	rcentier = 3104;
	rccli = 3168;	rcsti = 3200;	rcin = 3232;	rcout = 3264;
	rcassembler = 3296;
	rcclear= 3328;	rcstd= 3392;

	fload= 2528;	fstore = 2560;	fist= 2592;	fild = 2624;
	fadd = 2656;	fsub = 2688;	fmul = 2720;	fdiv = 2752;
	fabs = 2784;	fchs = 2816;	fcmp = 2848;

	newStat  = 3136;
  finlabel = 3456;

  sLd = rcld DIV 32;	sLdbdw = rcldbdw DIV 32;	sLdwdw = rcldwdw DIV 32;	sLdbw = rcldbw DIV 32;
	sLdbdwu = rcldbdwu DIV 32;	sLdwdwu = rcldwdwu DIV 32;   sLdbwu = rcldbwu DIV 32;	sGETreg = rcgetReg DIV 32;
	sPUTreg = rcputReg DIV 32;	sLdProc = rcldProc DIV 32;	sLdXProc = rcldXProc DIV 32;	sLea = rclea DIV 32;
	sSto = rcstore DIV 32;	sPush = rcpush DIV 32;	sPop = rcpop DIV 32;	sAdd = rcadd DIV 32;
	sSub = rcsub DIV 32;	sMul = rcmul DIV 32;	sDiv = rcdiv DIV 32;	sMod = rcmod DIV 32;
	sNeg= rcneg DIV 32;	sAbso = rcabs DIV 32;	sCmp = rccmp DIV 32;	sJe = rcje DIV 32;
	sJne = rcjne DIV 32;	sJl = rcjl DIV 32;	sJle = rcjle DIV 32;	sJg = rcjg DIV 32;
	sJge = rcjge DIV 32;	sJa = rcja DIV 32;	sJae = rcjae DIV 32;	sJb = rcjb DIV 32;
	sJbe = rcjbe DIV 32;	sJc = rcjc DIV 32;	sJnc = rcjnc DIV 32;	sJmp = rcjmp DIV 32;
	sJmpReg = rcjmpReg DIV 32;	sSete = rcsete DIV 32;	sSetne = rcsetne DIV 32;	sSetl = rcsetl DIV 32;
	sSetle = rcsetle DIV 32;	sSetg = rcsetg DIV 32;	sSetge = rcsetge DIV 32;	sSeta = rcseta DIV 32;
	sSetae = rcsetae DIV 32;	sSetb = rcsetb DIV 32; sSetbe = rcsetbe DIV 32;	sSetc = rcsetc DIV 32;
	sSetnc = rcsetnc DIV 32;	sTe = rcte DIV 32;	sTne = rctne DIV 32;	sTle = rctle DIV 32;
	sTa = rcta DIV 32;	sTae = rctae DIV 32;	sTo = rcto DIV 32;
	sTrap = rctrap DIV 32;	soR = rcor DIV 32;	sXor = rcxor DIV 32;	sAnd = rcand DIV 32;
	sNot = rcnot DIV 32;	sBt = rcbt DIV 32;	sBtr = rcbtr DIV 32;	sBts = rcbts DIV 32;	sTest = rctest DIV 32;
	sCall = rccall DIV 32;	sCallReg = rccallReg DIV 32;	sXcall = rcxcall DIV 32;	sRet = rcret DIV 32;
	sEnter = rcenter DIV 32;	sLeave = rcleave DIV 32;	sSal = rcsal DIV 32;	sSar = rcsar DIV 32;
	sShr= rcshr DIV 32;	sRol = rcrol DIV 32;	sCld = rccld DIV 32;	sRepMovs = rcrepMovs DIV 32;
	sCmpString = rccmpString DIV 32; sPushReg = rcpushReg DIV 32;	sPopReg = rcpopReg DIV 32;	sCase= rccase DIV 32;
	sShort = rcshort DIV 32;	sPhi = rcphi DIV 32 ;	sLabel = rclabel DIV 32;	sEntier = rcentier DIV 32;
	sCli = rccli DIV 32;	sSti = rcsti DIV 32;	sIn = rcin DIV 32;	sOut = rcout DIV 32;
	sAssembler = rcassembler DIV 32;
	sClear = rcclear DIV 32; sStd = rcstd DIV 32;

	(* floating point *)
	sFLoad= fload DIV 32;	sFStore = fstore DIV 32;	sFist= fist DIV 32;	sFild = fild DIV 32;
	sFadd = fadd DIV 32;	sFsub = fsub DIV 32;	sFmul = fmul DIV 32;	sFdiv = fdiv DIV 32;
	sFabs= fabs DIV 32;	sFchs = fchs DIV 32;	sFcmp = fcmp DIV 32;

	sNewStat = newStat DIV 32;
  sFinLabel = finlabel DIV 32;

  none = -1; RiscFP = -2; RiscESP = -3;

  LinkLength 	  = 512;
  MaxCommands 	= 128;	(* maximum commands in a Module *)
  MaxEntry      = 128;
  aNil	        = OPM.LANotAlloc;

  CaseTabelIndex      = 0;
  CaseTableEntryNr    = 255;
  LocProcAssIndex     = 1;
  LocProcAssEntryNr   = 254;
  NewLinkIndex        = 2;
  NewEntryNr          = 253;
  NewSysLinkIndex     = 3;
  NewSysEntryNr       = 252;
  NewArrayLinkIndex   = 4;
  NewArrayEntryNr     = 251;
  StartIndex          = 5;
  StartEntryNr        = 250;
  AwaitIndex          = 6;
  AwaitEntryNr        = 249;
  LockIndex           = 7;
  LockEntryNr         = 247;
  UnlockIndex         = 8;
  UnlockEntryNr       = 246;

  EntryTag      = #$82;
  commandTag    = #$83;
  pointerTag    = #$84;
  importTag     = #$85;
  VarConsLinkTag= #$8D;
  LinkTag       = #$86;
  DataTag       = #$87;
  ExportTag     = #$88;
  CodeTag       = #$89;
  UseTag        = #$8A;
  TypeTag       = #$8B;
  RefTag        = #$8C;

  EUEnd         = #0;
  EURecord      = #1;
  EUProcFlag    = $080000000;

  Experimental  = TRUE;
  InitLinks     = 9;

  nofTrapFixups = 10;
  free          = -1;
  Occupied      = MinInt;
  Splitted      = Occupied + 1; (* Register *)

  SplittableReg = [EAX, ECX, EDX, EBX, AX, CX, DX, BX];

  BADD = 0; BADC = $10; BSUB = $28; BSBB = $18; BCMP = $38; BAND = $20; BOr = $8; BXOR = $30;
  BWAIT = $9B; BROL = 0; BROR = 1; BRCL = 2; BRCR = 3; BSHL = 4; BSAL = 4; BSHR = 5; BSAR= 7;
  BSAHF = $9E; BCLD = $0FC; BSTD = $0FD; BCBW = $98; BCWD = $99 (* = CDQ *);
  BCLI = $0FA; BSTI = $0FB;
  BCMPS = $53; BINS = $36; BLODS = $56; BMOVS = $52; BOUTS = $37; BSCAS = $57; BTOS = $55;

  JO = 0; JNO = 1; JB = 2; JC = 2; JNAE = 2; JNB = 3; JNC = 3; JAE = 3; JE = 4; JZ = 4;
  JNE = 5; JNZ = 5; JBE = 6; JNA = 6; JNBE =7; JA = 7; JS = 8; JNS = 9; JP = 10; JPE = 10;
  JNP = 11; JPO = 11; JL = 12; JNGE = 12; JNL = 13; JGE = 13; JLE = 14; JNG = 14;
  JNLE = 15; JG = 15;

  useReg = [useEAX, useECX, useEDX, useEBX, useESP, useEBP, useESI, useEDI];
  tryReg = [tryEAX, tryECX, tryEDX, tryEBX, tryESI, tryEDI];

  MaxSaveLevel	= 32;

  sReal = OPOi386.sReal; 	(* short real 32 bit = Bit32 *)
  lRReal = OPOi386.lRReal; 	(* long real 64 bit *)
  eReal = OPOi386.eReal;	(* extended real 80 bit, only valid in GenFLD, GenFSTP *)
  sIInt = OPOi386.sIInt;

  gSETO = 0; gSETNO = 1; gSETB = 2; gSETNAE = 2; gSETAE = 3; gSETNB = 3; gSETE = 4; gSETZ = 4; gSETNE = 5; gSETNZ = 5;
  gSETBE = 6; gSETNA = 6; gSETNBE = 7; gSETA = 7; gSETS = 8; gSETNS = 9; gSETP = 10; gSETPE = 10;
  gSETNP = 11; gSETPO = 11; gSETL = 12; gSETNGE = 12; gSETNL = 13; gSETGE = 13; gSETLE = 14; gSETNG = 14;
  gSETNLE = 15; gSETG = 15;

TYPE
  ExpTable    = ARRAY OF LONGINT;
  PtrTable    = ARRAY OF LONGINT;

  ExTableEntry = ^ExTabEntry;
  ExTabEntry = RECORD
    pcFrom, pcTo, pcHandler: LONGINT;
    next: ExTableEntry;
  END;

  LinkRec = RECORD
    offset, vmod, entry: INTEGER;
  END;

  VarConsRec = RECORD
    vmod, entry, noflinks, index: INTEGER
  END;
  VarConsTable = ARRAY OF VarConsRec;

  VarConsLinkRec = RECORD
    offset, next: INTEGER
  END;
  VarConsLinkTable = ARRAY OF VarConsLinkRec;

  Map = ^MapDesc;
  MapDesc = ARRAY OF RECORD
    pos, pc : LONGINT
  END;

  SavedRegRec = RECORD
    reg, sreg, freg: ARRAY [0..8] OF INTEGER
  END;

VAR
  nofVarCons, noVarEntries, nofptrs,
  nofVarConsLinks, nofLinks: INTEGER;
  RegErr, VarEntryErr, LinkErr: BOOLEAN;
  link: ARRAY [0..LinkLength] OF LinkRec;
  nofSavedLevel: INTEGER;
  varConsLink: VarConsTable;
  nofStr: INTEGER;
  exppos: LONGINT;
  explist: ExpTable;
  ptrTab: PtrTable;
  varConsTab: VarConsLinkTable;

  mapSize : LONGINT;
  vmap    : Map;
  ftop    : SHORTINT;
  FreeRegDisp: SHORTINT;
  trapFixupTab: ARRAY [0..nofTrapFixups] OF LONGINT;
  regTab, sregTab, fregTab: ARRAY [0..8] OF LONGINT;

  JmpConvert: ARRAY [0..sJnc-sJe+1] OF SHORTINT;
  SetccConvert: ARRAY [0..sSetnc - sSete + 1] OF SHORTINT;
  savedRegs: ARRAY [0..MaxSaveLevel] OF SavedRegRec;

  PROCEDURE Init;
  PROCEDURE NewLink(vmod, entry: LONGINT; VAR index: LONGINT);
  PROCEDURE FixupLocalProcCall(proc: OPT.Objects);
  PROCEDURE OPLBegin;
  PROCEDURE OutCode(VAR modName: STRING);
  PROCEDURE GenCode (pSize: INTEGER);
  PROCEDURE NewVarCons(vmod, entry: INTEGER; VAR index: LONGINT);
  PROCEDURE CaseJump(vLabel, tab, from, vto: LONGINT);
  PROCEDURE Close;
  
IMPLEMENTATION

PROCEDURE Init;
BEGIN
  OPOi386.CodeErr := FALSE;
  VarEntryErr := FALSE;
  LinkErr := FALSE;
  noVarEntries := 0;
  nofptrs := 0;
  nofVarConsLinks := 0;
  nofSavedLevel := 0;
  varConsLink [0].noflinks := 0;
  varConsLink [0].entry := -1;
  varConsLink [0].index := noEntry;
  nofVarCons := 1;
  link [0].vmod := 0; link [0].entry := CaseTableEntryNr;  link [0].offset := aNil;  (* Case table fixup chain *)
  link [1].vmod := 0; link [1].entry := LocProcAssEntryNr; link [1].offset := aNil; (* Fixup chain for procedure assignments *)
  link [2].vmod := 0; link [2].entry := NewEntryNr;        link [2].offset := aNil;           (* Kernel.NewRec (VAR ptr, tag) *)
  link [3].vmod := 0; link [3].entry := NewSysEntryNr;     link [3].offset := aNil;      (* Kernel.NewSys (VAR ptr, size)  *)
  link [4].vmod := 0; link [4].entry := NewArrayEntryNr;   link [4].offset := aNil; (* Kernel.NewArray (VAR ptr, nofelems, nofdims, baseTag) *)
  link [5].vmod := 0; link [5].entry := StartEntryNr;      link [5].offset := aNil; (* Kernel.Start *)
  link [6].vmod := 0; link [6].entry := AwaitEntryNr;      link [6].offset := aNil; (* Kernel.Await *)
  link [7].vmod := 0; link [7].entry := LockEntryNr;       link [7].offset := aNil; (* Kernel.Lock *)
  link [8].vmod := 0; link [8].entry := UnlockEntryNr;     link [8].offset := aNil; (* Kernel.Unlock *)
  nofLinks := InitLinks;
END;

PROCEDURE NewLink(vmod, entry: LONGINT; VAR index: LONGINT);
BEGIN
  IF nofLinks >= LinkLength THEN BEGIN
    IF NOT LinkErr THEN BEGIN
      OPM.err (231);
      LinkErr := TRUE;
      index := 0
    END
  END ELSE BEGIN
    link [nofLinks].vmod := vmod;
    link [nofLinks].entry := entry;
    link [nofLinks].offset := aNil;
    index := nofLinks;
    INC (nofLinks)
  END
END;

PROCEDURE NewVarCons(vmod, entry: INTEGER; VAR index: LONGINT);
VAR
  i: LONGINT;
  vvar: VarConsTable;
BEGIN
  IF nofVarCons >= LENGTH(varConsLink) THEN BEGIN
    SETLENGTH(vvar, LENGTH(varConsLink)*2);
    FOR i := 0 TO LENGTH(varConsLink)-1 DO vvar[i] := varConsLink[i];
    varConsLink := vvar
  END;
  varConsLink[nofVarCons].vmod := vmod;
  varConsLink[nofVarCons].entry := entry;
  varConsLink[nofVarCons].noflinks := 0;
  varConsLink[nofVarCons].index := noEntry;
  index := nofVarCons;
  INC (nofVarCons)
END;

PROCEDURE CaseJump(vLabel, tab, from, vto: LONGINT);
BEGIN
  IF NOT OPL.ConstErr THEN BEGIN
    from := tab + 4 * from;
    vto := tab + 4 * vto;
    WHILE from <= vto DO BEGIN
      OPOi386.PutConsDWord (from, vLabel);
      from := from + 4
    END
  END
END;

PROCEDURE FixupLocalProcCall(proc: OPT.Objects);
VAR
  L, L1, entryNr: LONGINT;
BEGIN
  IF (proc.linkadr < 0) AND NOT(proc.mode IN [omTProc, omTyp]) THEN BEGIN
    L := -2-proc.linkadr-$10000;
    WHILE L > aNil DO BEGIN
      OPOi386.GetDWord (L+1, L1);
      OPOi386.PutDWordAt (L+1, OPOi386.pcc - (L + 5));
      L := -2-L1-$10000;
    END;
  END;
  proc.linkadr := OPOi386.pcc;
  IF (proc.mode IN [omXProc, omTProc, omTyp]) THEN BEGIN
    IF proc.mode IN [omTProc, omTyp] THEN
      entryNr := _SYSTEM._MOD(proc.adr,$10000)
    ELSE
      entryNr := proc.adr;
    IF OPOi386.pcc > 32767 THEN
      OPL.entry[entryNr] := OPOi386.pcc-$10000
    ELSE
      OPL.entry[entryNr] := OPOi386.pcc;
  END;
END;

//#######################################################################

FUNCTION ObjAllocInt: LONGINT;
VAR
  pos: LONGINT;
BEGIN
  pos:=OPM.ObjF.Position;
  OPM.SymWInt(OPM.ObjF,0);
  RESULT:= pos;
END;

PROCEDURE ObjFillInt(pos: LONGINT; int: INTEGER);
VAR
  savepos: LONGINT;
BEGIN
  savepos:=OPM.ObjF.Position;
  OPM.ObjF.Position:=pos;
  OPM.ObjF.Write(int, 2);
  OPM.ObjF.Position:=savepos;
END;

FUNCTION LSW (x: LONGINT): LONGINT;
BEGIN
  RESULT:= x AND $0FFFF; //***!!!
END;

PROCEDURE RefExport(obj: OPT.Objects; VAR nofExp: INTEGER);
VAR
  typ: OPT.Structs;
  i: LONGINT;
  tmp: ExpTable;

  PROCEDURE ExportMeth(fld: OPT.Objects; basetyp: OPT.Structs; VAR noFld: INTEGER);
  BEGIN
    IF fld<>NIL THEN BEGIN
      ExportMeth(fld.left, basetyp, noFld);
      IF (fld.mode=omTProc) AND (fld.vis<>internal) THEN BEGIN
        INC(noFld);
        SymWNum(ObjF,fld.fp);	(* mfix *) //***!!!
      END;
      ExportMeth(fld.right, basetyp, noFld)
    END;
  END;

  PROCEDURE ExportRecord(typ: OPT.Structs);
  VAR
    fld: OPT.Objects;
    pos: LONGINT;
    nofld: INTEGER;
  BEGIN 
    IF typ.mno=0 THEN BEGIN
      SymWCh(ObjF,EURecord);
      IF typ.oref<>0 THEN
        SymWNum(ObjF,-typ.oref)	(* old Type *)
      ELSE BEGIN
        INC(nofStr);
        typ.oref:=nofStr;
        SymWNum(ObjF,typ.tdadr);
        OPT.FPrintTyp(typ);
        pos:=ObjAllocInt;
        nofld:=2; 
        IF (typ.BaseTyp<>NIL) AND (typ.mno=OPT.modNo) THEN ExportRecord(typ.BaseTyp);
        SymWNum(ObjF,typ.pbfp);
        SymWNum(ObjF,typ.pvfp);
        ExportMeth(typ.link, typ.BaseTyp, nofld);
        fld:=typ.link;
        WHILE (fld<>NIL) AND (fld.mode<>omTProc) DO BEGIN
          IF fld.vis<>internal THEN BEGIN
            INC(nofld); 
            SymWNum(ObjF,fld.fp);
            typ:=fld.typ;
            WHILE (typ<>NIL) AND ((typ.form=sfComp) AND (typ.comp<>csRecord)
            OR (typ.form=sfPointer)) DO typ:=typ.BaseTyp;
            IF (typ<>NIL) AND (typ.form=sfComp) AND (typ.comp=csRecord) THEN ExportRecord(typ);
          END;
          fld:=fld.link;
        END;
        SymWCh(ObjF,EUEnd);
        ObjFillInt(pos, nofld);
      END;
    END;
  END;

BEGIN 
  IF obj<>NIL THEN BEGIN
    IF obj.prio=127 THEN BEGIN
      RefExport(obj.link2, nofExp);
      RefExport(obj.left, nofExp);
      RefExport(obj.right, nofExp)
    END ELSE BEGIN
      RefExport(obj.left, nofExp);
      IF (obj.vis<>internal) THEN BEGIN
        OPT.FPrintObj(obj);
        SymWNum(ObjF,obj.fp);
        i := 0;
        WHILE i < exppos DO BEGIN
          IF obj.fp = explist[i] THEN OPM.Mark(280, obj.errpos);
          INC(i)
        END;
        IF exppos = LENGTH(explist) THEN BEGIN	(*grow*)
          SETLENGTH(tmp, 32+LENGTH(explist));
          MOVE(explist[0],tmp[0], 4*LENGTH(explist));
          explist := tmp;
        END;
        explist[exppos] := obj.fp;
        INC(exppos);
        IF obj.mode = omVar THEN
          SymWNum(ObjF,obj.linkadr)
        ELSE IF obj.mode = omXProc THEN
          SymWNum(ObjF,LSW(entry[obj.adr]))
        ELSE
          SymWCh(ObjF,#0);
        INC(nofExp);
        IF (obj.mode=omTyp) OR (obj.mode=omVar) THEN BEGIN
          typ:=obj.typ; 
          WHILE (typ<>NIL) AND ((typ.form=sfComp) AND (typ.comp<>csRecord)
          OR (typ.form=sfPointer)) DO typ:=typ.BaseTyp;
          IF (typ<>NIL) AND (typ.form=sfComp) AND (typ.comp=csRecord) THEN ExportRecord(typ);
        END;
      END;
      RefExport(obj.right, nofExp)
    END	
  END
END;

PROCEDURE Use(obj: OPT.Objects);
VAR
  typ: OPT.Structs;
  alias: BOOLEAN;

  PROCEDURE UseRecord(typ: OPT.Structs);
  VAR
    name: STRING;
  BEGIN
    IF (typ.oref=0) AND (typ.mno=OPT.modNo) THEN BEGIN
      OPM.SymWCh(OPM.ObjF,EURecord);
      IF	(typ.tdadr=OPM.TDAdrUndef) OR (typ.tdadr=-2)	THEN
        OPM.SymWNum(OPM.ObjF,0)
      ELSE
        OPM.SymWNum(OPM.ObjF,-typ.tdadr);
      OPT.FPrintTyp(typ);
      typ.oref:=-1;
      IF typ.pvused THEN BEGIN
        name:='@';
        OPM.SymWNum(OPM.ObjF,typ.pvfp);
        OPM.SymWString(OPM.ObjF,name);
      END ELSE IF typ.pbused THEN	BEGIN
        name:='@';
        OPM.SymWNum(OPM.ObjF,typ.pbfp);
        OPM.SymWString(OPM.ObjF,name);
      END;
      OPM.SymWCh(OPM.ObjF,EUEnd);
    END;
  END;

BEGIN
  IF obj<>NIL THEN BEGIN
    IF obj.prio=127 THEN BEGIN
      Use(obj.link2);
      Use(obj.left);
      Use(obj.right)
    END ELSE BEGIN
      Use(obj.left);
      alias := FALSE;
      IF NOT obj.used AND (obj.mode = omTyp) AND (obj.vis<>internal) AND (obj.typ.strobj <> obj) AND
        (obj.typ.strobj.vis=internal) AND obj.typ.strobj.used THEN BEGIN
        alias := TRUE;
        //OPM.LogWLn; OPM.LogWStr("  OPL.Use, (strobj) "); OPM.LogWStr(obj.name)
      END;
      IF alias OR obj.used AND (obj.vis<>internal)
      AND ((obj.mode<>omXProc) OR (_SYSTEM._DIV(obj.adr,$10000) <> 0) AND (link[_SYSTEM._DIV(obj.adr,$10000)].offset <> aNil))
      AND ((obj.mode<>omVar) OR (obj.adr<>0)) THEN BEGIN
        OPT.FPrintObj(obj);
        OPM.SymWNum(OPM.ObjF,obj.fp);
        OPM.SymWString(OPM.ObjF,obj.name);
        IF obj.mode = omVar THEN
          OPM.SymWNum(OPM.ObjF,_SYSTEM._DIV(obj.adr,$10000))
        ELSE IF obj.mode = omXProc THEN
          OPM.SymWNum(OPM.ObjF,LSW(link[_SYSTEM._DIV(obj.adr,$10000)].offset) + LONGINT(EUProcFlag))
        ELSE
          OPM.SymWCh(OPM.ObjF,#0);
        IF (obj.mode=omTyp) OR (obj.mode=omVar) THEN BEGIN
          typ:=obj.typ; 
          WHILE (typ<>NIL) AND ((typ.form=sfComp) AND (typ.comp<>csRecord) OR (typ.form=sfPointer)) DO typ:=typ.BaseTyp;
          IF (typ<>NIL) AND (typ.form=sfComp) AND (typ.comp=csRecord) THEN BEGIN
            UseRecord(typ);
            IF typ.strobj.fp = 0 THEN typ.strobj.fp := obj.fp;
          END;
        END;
      END;
      Use(obj.right);
    END					
  END
END;

PROCEDURE OutCode(VAR modName: STRING);
VAR
  i, k, pos: LONGINT;
  nofcmds, nofnewmth, nofinhmth, linkCorrection, nofExp: INTEGER;
  obj: OPT.Objects;
  typ, btyp: OPT.Structs;
  commandTab: ARRAY [0..MaxCommands] OF OPT.Objects;
  newMthTab: ARRAY [0..MaxEntry] OF OPT.Objects;
	
  PROCEDURE WriteName (VAR name: STRING);
  VAR
    i: INTEGER;
    ch: CHAR;
  BEGIN
    i := 1;
    IF name='' THEN name:=#0;
    REPEAT
      ch := name[i]; 
      OPM.SymWCh(OPM.ObjF,ch);
      INC (i)
    UNTIL ch = #0;
  END;
		
  PROCEDURE FindPtrs (typ: OPT.Structs; adr: LONGINT);
    VAR
      fld: OPT.Objects;
      i, n, s: LONGINT;
      btyp: OPT.Structs;
				
      PROCEDURE Add(adr: LONGINT);
      VAR
        table: PtrTable;
        i: INTEGER;
      BEGIN
        IF nofptrs >= LENGTH(ptrTab) THEN BEGIN
          SETLENGTH(table, LENGTH(ptrTab)*2);
          FOR i:=0 TO LENGTH(ptrTab)-1 DO  table[i]:=ptrTab[i];
          ptrTab:=table;
        END;
        ptrTab[nofptrs] := adr;
        INC (nofptrs);
      END;

  BEGIN
    IF typ.form = sfPointer THEN BEGIN
      IF (typ.sysflag=0) THEN Add(adr);
    END ELSE IF typ.comp = csRecord THEN BEGIN
      btyp := typ.BaseTyp;
      IF btyp <> NIL THEN FindPtrs (btyp, adr);
      fld := typ.link;
      WHILE (fld <> NIL) AND (fld.mode = omFld) DO BEGIN
        IF (fld.name = OPT.HdPtrName) THEN
          Add(adr)
        ELSE IF fld.sysflag <> untraced THEN
          FindPtrs (fld.typ, fld.adr + adr);
        fld := fld.link
      END
    END ELSE IF typ.comp = csStaticArr THEN BEGIN
      btyp := typ.BaseTyp;
      n := typ.n;
      WHILE btyp.comp = csStaticArr DO BEGIN
        n := btyp.n * n;
        btyp := btyp.BaseTyp;
      END;
      IF (btyp.form = sfPointer) OR (btyp.comp IN [csRecord, csDynArr]) THEN BEGIN
        i := 0;
        s := btyp.size;
        WHILE i < n DO BEGIN
          FindPtrs (btyp, i * s + adr);
          INC (i)
        END;
      END;
    END ELSE IF typ.comp = csDynArr THEN
      Add(adr);
  END;
		
  PROCEDURE traverse (obj: OPT.Objects);
  VAR
    u: INTEGER;
  BEGIN
    IF obj <> NIL THEN BEGIN
      IF obj.mode = omXProc THEN BEGIN
        IF (obj.vis <> internal) AND (obj.link = NIL) AND (obj.typ = OPT.notyp) THEN BEGIN(* command *)
          u := 1;
          WHILE obj.name[u] > #0 DO INC (u);
          IF nofcmds <= MaxCommands THEN BEGIN
            commandTab[nofcmds] := obj;
            INC (nofcmds);
          END ELSE
            OPM.err (232);
        END
      END ELSE IF (obj.mode = omVar) AND (obj.sysflag <> untraced) THEN
        FindPtrs (obj.typ, obj.linkadr);
      traverse (obj.left);
      traverse (obj.right)
    END
  END;
		
  PROCEDURE FindNewMths (obj: OPT.Objects);
  BEGIN
    IF obj <> NIL THEN BEGIN
      IF (obj.mode = omTProc) OR ((obj.mode = omTyp) AND (obj.conval <> NIL)
      AND (hasBody IN obj.conval^.setval)) THEN BEGIN
        newMthTab[nofnewmth] := obj; 
        INC (nofnewmth)
      END;
      IF obj.mode = omTyp THEN
        FindNewMths (obj.typ.link)
      ELSE BEGIN
        FindNewMths (obj.left);
        FindNewMths (obj.right)
      END;
     END;
  END;

BEGIN (*  OutCode *)
  linkCorrection := 0;
  i := 0;
  WHILE i < nofLinks DO BEGIN
    IF (link[i].offset = aNil) OR (link[i].vmod > 0) THEN INC (linkCorrection);
    INC (i)
  END;
  i :=  _SYSTEM._MOD(-OPOi386.csize,4);
  WHILE i > 0 DO BEGIN
    OPOi386.constant[OPOi386.csize] := #0;
    INC (OPOi386.csize);
    DEC (i);
  END;
  nofcmds := 0;
  traverse (OPT.topScope.right); (* collect commands and pointers *)
(* header block *)
  OPM.SymWInt(OPM.ObjF,OPL.nofEntries);
  OPM.SymWInt(OPM.ObjF,nofcmds);
  OPM.SymWInt(OPM.ObjF,nofptrs);
  OPM.SymWInt(OPM.ObjF,OPL.nofrecs);
  OPM.SymWInt(OPM.ObjF,OPT.nofmod-1);
  OPM.SymWInt(OPM.ObjF,nofVarCons);
  OPM.SymWInt(OPM.ObjF,nofLinks-linkCorrection);
  OPM.SymWBytes (OPM.ObjF,OPOi386.dsize, 4);
  OPM.SymWInt(OPM.ObjF,OPOi386.csize);
  OPM.SymWInt(OPM.ObjF,OPOi386.pcc);
  WriteName(modName);
(* entry block *)
  OPM.SymWCh(OPM.ObjF,EntryTag);
  i := 0;
  WHILE i < OPL.nofEntries DO BEGIN
    OPM.SymWInt(OPM.ObjF,OPL.entry[i]);
    INC(i);
  END;
(* command block *)
  OPM.SymWCh(OPM.ObjF,commandTag);
  i := 0; (* write command names and entry addresses *)
  WHILE i < nofcmds DO BEGIN
    obj := commandTab[i];
    WriteName (obj.name);
    OPM.SymWInt(OPM.ObjF,OPL.entry[_SYSTEM._MOD(obj.adr,$10000)]);
    INC (i);
  END;
(* pointer block *)
  OPM.SymWCh(OPM.ObjF,pointerTag);
  i := 0;
  WHILE i < nofptrs DO BEGIN
    OPM.SymWBytes (OPM.ObjF,ptrTab[i], 4);
    INC (i)
  END;
(* import block *)
  OPM.SymWCh(OPM.ObjF,importTag);
  i := 1;
  WHILE i < OPT.nofmod DO BEGIN
    obj := OPT.modulesx[i];
    WriteName (obj.name); (* name *)
    INC (i)
  END;
(* VarConsLink block *)
  OPM.SymWCh(OPM.ObjF,VarConsLinkTag);
  i := 0;
  WHILE i < nofVarCons DO BEGIN
    OPM.SymWCh(OPM.ObjF,CHR(varConsLink[i].vmod));
    OPM.SymWInt(OPM.ObjF,varConsLink[i].entry);
    OPM.SymWInt(OPM.ObjF,varConsLink[i].noflinks);
    k := varConsLink[i].index;
    WHILE k <> noEntry DO BEGIN
      OPM.SymWInt(OPM.ObjF,varConsTab[k].offset);
      k := varConsTab[k].next
    END;
    INC (i)
  END;
(* link block *)
  OPM.SymWCh(OPM.ObjF,LinkTag);
  i := 0;
  WHILE i < nofLinks DO BEGIN
    IF (link[i].offset <> aNil) AND (link[i].vmod <= 0) THEN BEGIN
      OPM.SymWCh(OPM.ObjF,CHR(link[i].vmod));
      OPM.SymWCh(OPM.ObjF,CHR(link[i].entry));
      OPM.SymWInt(OPM.ObjF,link[i].offset);
    END;
    INC (i)
  END;
(* data block *)
  OPM.SymWCh(OPM.ObjF,DataTag);
  i := 0;
  WHILE i < OPOi386.csize DO BEGIN
    OPM.SymWCh(OPM.ObjF,OPOi386.constant[i]);
    INC (i)
  END;
(* export block *)
  OPM.SymWCh(OPM.ObjF,ExportTag);
  pos := ObjAllocInt;
  nofExp := 0;
  nofStr := 0;
  OPT.modNo := 0;
  IF Experimental THEN exppos := 0;
  RefExport(OPT.topScope.right, nofExp);
  OPM.SymWCh(OPM.ObjF,EUEnd);
  ObjFillInt(pos, nofExp);
(* code size *)
  OPM.SymWCh(OPM.ObjF,CodeTag);
  i := 0;
  WHILE i < OPOi386.pcc DO BEGIN
    OPM.SymWCh(OPM.ObjF,OPOi386.code[i]);
    INC (i)
  END;
(* use block *)
  OPM.SymWCh(OPM.ObjF,UseTag);
  i := 1;
  WHILE i < OPT.nofmod DO BEGIN
    IF OPT.modulesx[i].used THEN BEGIN
      OPM.SymWString(OPM.ObjF,OPT.modulesx[i].name);
      OPT.modNo := i;
      Use(OPT.modulesx[i].right);
      OPM.SymWCh(OPM.ObjF,EUEnd)
    END;
    INC(i)
  END;
  OPM.SymWCh(OPM.ObjF,EUEnd);
(* type block *)
  OPM.SymWCh(OPM.ObjF,TypeTag);
  i := 0;
  WHILE i < OPL.nofrecs DO BEGIN
    typ := recTab[i];
    nofptrs := 0;
    FindPtrs (typ, 0);
    OPM.SymWBytes (OPM.ObjF,typ.size,4); (* record size *)
    OPM.SymWInt(OPM.ObjF,typ.tdadr);	(* td adr *)
    btyp := typ.BaseTyp;
    IF btyp = NIL THEN BEGIN
      nofinhmth := 0;
      OPM.SymWInt(OPM.ObjF,-1);
      OPM.SymWLInt(OPM.ObjF,-1);
    END ELSE BEGIN
      nofinhmth := btyp.n;
      OPM.SymWInt(OPM.ObjF,btyp.mno);
      IF btyp.mno = 0 THEN
        OPM.SymWBytes(OPM.ObjF,btyp.tdadr, 4)
      ELSE
        OPM.SymWLInt(OPM.ObjF,btyp.strobj.fp);
    END;
    OPM.SymWInt(OPM.ObjF,typ.n);
    OPM.SymWInt(OPM.ObjF,nofinhmth);
    nofnewmth := 0;
    FindNewMths (typ.strobj);
    OPM.SymWInt(OPM.ObjF,nofnewmth);
    OPM.SymWInt(OPM.ObjF,nofptrs);
    IF (typ.strobj <> NIL) AND (typ.strobj.mnolev = 0) THEN BEGIN
      IF typ.ptr <> NIL THEN BEGIN
        IF typ.ptr.strobj = NIL THEN
          WriteName(typ.strobj.name)
        ELSE
          WriteName(typ.ptr.strobj.name);
      END ELSE
        WriteName (typ.strobj.name);
    END ELSE
      OPM.SymWCh(OPM.ObjF,#0);
    WHILE nofnewmth > 0 DO BEGIN
      DEC (nofnewmth);
      OPM.SymWInt(OPM.ObjF,_SYSTEM._DIV(newMthTab[nofnewmth].adr,$10000)); (* method number *)
      OPM.SymWInt(OPM.ObjF,_SYSTEM._MOD(newMthTab[nofnewmth].adr,$10000)); (* entry number *)
    END;
    k := 0;
    WHILE k < nofptrs DO BEGIN
      OPM.SymWBytes(OPM.ObjF,ptrTab[k],4);
      INC(k)
    END;
    INC (i);
  END;
  OPM.CloseObj(modName);
END;

//######################################################################

FUNCTION loaded (pReg: LONGINT): BOOLEAN;
BEGIN
  IF pReg > none THEN
    RESULT:= (InstrTab [pReg].reg > none)
  ELSE
    RESULT:= ((pReg = RiscESP) OR (pReg = RiscFP));
END;
	
PROCEDURE FindReg (pReg: LONGINT; VAR reg: SHORTINT);
BEGIN
  ASSERT (loaded (pReg));
  IF pReg > none THEN
    reg := InstrTab [pReg].reg
  ELSE IF pReg = RiscESP THEN
    reg := ESP
  ELSE
    reg := EBP;
END;

PROCEDURE FixupJcc (vlabel: LONGINT);
VAR
  pos, nextLabel: LONGINT;
BEGIN
  WHILE vlabel <> aNil DO BEGIN
    IF InstrTab[vlabel].op = rcjmp THEN
      pos := InstrTab [vlabel].pc + 1
    ELSE (* jcc *)
      pos := InstrTab [vlabel].pc + 2;
    OPOi386.GetDWord (pos, nextLabel);
    OPOi386.PutDWordAt (pos, OPOi386.pcc - (pos + 4));
    vlabel := -2 - nextLabel - $10000
  END
END;

FUNCTION LastUse (reg: SHORTINT): BOOLEAN;
VAR
  pReg: LONGINT;
BEGIN
  ASSERT (reg IN [EAX..BH]);
  IF reg >= AL THEN
    pReg := sregTab [reg-AL]
  ELSE
    pReg := regTab [_SYSTEM._MOD(reg,8)];
  IF pReg > none THEN BEGIN
    RESULT:= InstrTab[pReg].used = 1;
    EXIT;
  END ELSE BEGIN
    ASSERT (reg IN [ESP, SP, EBP, BP]);
    RESULT:= TRUE;
  END;
END;

PROCEDURE Load (VAR instr: Instruction); FORWARD;

PROCEDURE FindLoadReg (pReg: LONGINT; VAR reg: SHORTINT);
BEGIN
  IF pReg > none THEN BEGIN
    IF NOT loaded (pReg) THEN Load (InstrTab [pReg]);
    reg := InstrTab [pReg].reg
  END ELSE IF pReg = RiscESP THEN
    reg := ESP
  ELSE IF pReg = RiscFP THEN
    reg := EBP
  ELSE
    reg := none
END;

PROCEDURE FindMemReg (VAR instr: Instruction; VAR mode, scale, size, base, inx: SHORTINT; VAR disp: LONGINT);
BEGIN
  size := _SYSTEM._MOD(instr.op,8) * 8;
  mode := _SYSTEM._MOD(_SYSTEM._DIV(instr.op,8),4);
  scale := instr.scale;
  IF mode IN [MemReg, RegMem] THEN BEGIN
    FindLoadReg (instr.src1, base);
    disp := instr.src2;
    FindLoadReg (instr.inx, inx)
  END ELSE IF mode = RegReg THEN BEGIN
    FindLoadReg (instr.src1, base);
    disp := noDisp;
    inx := none
  END ELSE BEGIN(* mode = ImmReg *)
    ASSERT (mode = ImmReg);
    base := noBase;
    disp := noDisp;
    inx := none
  END;
END;

PROCEDURE FreeReg (reg: SHORTINT);
VAR
  i: SHORTINT;
BEGIN
  IF (reg > none) AND NOT(reg IN [ESP, SP, EBP, BP]) THEN BEGIN
    IF reg IN [AL..BH] THEN BEGIN
      i := reg-AL;
      IF sregTab [i] >= 0 THEN InstrTab [sregTab [i]].reg := -2-reg;
      sregTab [i] := free;
      IF i < 4 THEN BEGIN
        IF sregTab [i+4] = free THEN regTab [i] := free;
      END ELSE IF sregTab [i-4] = free THEN
        regTab [_SYSTEM._MOD(i,4)] := free;
    END ELSE BEGIN
      i := _SYSTEM._MOD(reg,8);
      IF regTab [i] >= 0 THEN InstrTab [regTab [i]].reg := -2-reg;
      IF i IN [ESP, SP, EBP, BP] THEN
        regTab [i] := Occupied
      ELSE
        regTab [i] := free;
    END
  END
END;

PROCEDURE DecReg (reg: SHORTINT); (* only used by DecCheckReg, Store, GenPush, Gen0, GenFlags *)
VAR
  pReg: LONGINT;
BEGIN
  IF reg > none THEN BEGIN
    IF reg >= AL THEN
      pReg := sregTab [reg-AL]
    ELSE
      pReg := regTab [_SYSTEM._MOD(reg,8)];
    IF pReg > none THEN BEGIN
      DEC (InstrTab [pReg].used);
      IF (InstrTab [pReg].used = 0) AND (InstrTab [pReg].reg > aNil) THEN FreeReg (InstrTab [pReg].reg);
    END
  END
END;

PROCEDURE GetThisReg (this: SHORTINT);  FORWARD;
	
PROCEDURE GetReg8 (VAR reg: SHORTINT);
VAR
  i: SHORTINT;
BEGIN
  i := EBX;
  WHILE (i >= EAX) AND NOT((regTab[i] = Splitted) AND ((sregTab[i] = free) OR (sregTab[i+4] = free))) DO DEC (i);
  IF i < EAX THEN BEGIN(* in splitted registers are no 8 bit registers free *)
    i := EBX;
    WHILE (i >= EAX) AND (regTab [i] <> free) DO DEC (i); (* search a free splittable register *)
    IF i < EAX THEN BEGIN(* no free splittable register *)
      i := EBX; (* look for a splittable register which is unsplitted *)
      WHILE (i >= EAX) AND (regTab [i] = Splitted) DO DEC (i);
      IF i < EAX THEN BEGIN
        OPM.err (215);
        RegErr := TRUE;
        reg := AL; 
        EXIT;
      END;
    END;
    GetThisReg (i);
    regTab [i] := Splitted
  END ELSE IF sregTab [i] <> free THEN
    INC (i,4);
  sregTab [i] := Occupied;
  reg := i+AL
END;
	
PROCEDURE GetThisReg8 (this: SHORTINT);
(* this IN {AL..BH} *)
VAR
  i, reg: SHORTINT;
BEGIN
  ASSERT (this IN [AL..BH]);
  reg := _SYSTEM._MOD(this,4); (* = splitted 32/16 bit register *)
  IF (regTab [reg] = Splitted) AND (sregTab [this-AL] = free) THEN
    sregTab [this-AL] := Occupied
  ELSE IF regTab [reg] <> free THEN BEGIN
    IF regTab [reg] = Splitted THEN BEGIN(* 8 bit register is occupied -> move value to another register *)
      GetReg8 (i);
      ASSERT (sregTab [this - AL] >= 0);
      InstrTab [sregTab [this-AL]].reg := i;
      OPOi386.GenMOV(RegReg, i, this, noInx, noScale, noDisp, noImm);
      sregTab [i - AL] := sregTab [this-AL];
      sregTab [this-AL] := Occupied
    END ELSE BEGIN
      GetThisReg (reg);
      regTab [reg] := Splitted;	(*regTab [i] := Splitted;		, bug found by C.Steindl, fix by prk *)
      sregTab [this-AL] := Occupied
    END
  END ELSE BEGIN
    regTab [reg] := Splitted;
    sregTab [this-AL] := Occupied
  END
END;
	
PROCEDURE GetSplittableReg (VAR reg: SHORTINT);
VAR
  r: SHORTINT;
BEGIN
  r := EBX;
  WHILE (r >= EAX) AND (regTab [r] <> free) DO DEC (r);
  IF r < EAX THEN BEGIN
    r := EBX;
    WHILE (r >= EAX) AND (regTab [r] = Splitted) DO DEC (r);
    IF r < EAX THEN BEGIN
      OPM.err (215);
      RegErr := TRUE;
      reg := EAX;
      EXIT;
    END;
    GetThisReg (r)
  END;
  regTab [r] := Occupied;
  reg := r
END;
	
PROCEDURE OPLGetReg(VAR reg: SHORTINT);
VAR
  r: SHORTINT;
BEGIN
  r := EBX;
  WHILE (r >= EAX) AND (regTab [r] <> free) DO DEC (r);
  IF r < EAX THEN BEGIN
    IF regTab [EDI] = free THEN
      r := EDI
    ELSE IF regTab [ESI] = free THEN
      r := ESI;
  END;
  IF r < EAX THEN BEGIN
    OPM.err (215);
    RegErr := TRUE;
    reg := EAX;
    EXIT;
  END;
  regTab [r] := Occupied;
  reg := r
END;

PROCEDURE GetThisReg (this: SHORTINT);
VAR
  r, reg, r0, r1: SHORTINT;
  pReg: LONGINT;
BEGIN
  ASSERT (this IN [EAX..DI]);
  reg := _SYSTEM._MOD(this,8);
  IF regTab [reg] = Splitted THEN BEGIN
    regTab [reg] := Occupied;	(*prevent reallocation of the free part of the register, if any*)
    IF (sregTab [reg] = free) OR (sregTab [reg + 4] = free) THEN BEGIN
      IF sregTab [reg] = free THEN BEGIN
        r0 := reg + AL + 4;
        r1 := reg + 4
      END ELSE BEGIN
        r0 := reg + AL;
        r1 := reg;
      END;
      GetReg8 (r);
      OPOi386.GenMOV (RegReg, r, r0, noInx, noScale, noDisp, noImm);
      sregTab [r - AL] := sregTab [r1];
      InstrTab [sregTab [r1]].reg := r;
      sregTab [r1] := free
    END ELSE BEGIN
      r := EBX;
      WHILE (r >= EAX) AND (regTab [r] <> free) DO DEC (r); (* search any free, splittable register *)
      IF r < EAX THEN BEGIN(* no free splittable register *)
        GetReg8 (r0);
        OPOi386.GenMOV (RegReg, r0, reg + AL, noInx, noScale, noDisp, noImm); (* move lower 8 bit *)
        GetReg8 (r1);
        OPOi386.GenMOV (RegReg, r1, reg + AL + 4, noInx, noScale, noDisp, noImm);
          (* move higher 8 bit *)
      END ELSE BEGIN
        OPOi386.GenMOV (RegReg, r, reg, noInx, noScale, noDisp, noImm);
        r0 := r + AL;
        r1 := r0 + 4;
        regTab [r] := Splitted;
      END;
      sregTab [r0 - AL] := sregTab [reg + AL];
      InstrTab [sregTab [reg + AL]].reg := r0;
      sregTab [r0 - AL] := free;
      sregTab [r1 - AL] := sregTab [reg + AL + 4];
      InstrTab [sregTab [reg + AL + 4]].reg := r1;
      sregTab [r1 - AL] := free
    END;
    (*regTab [reg] := Occupied*)
  END ELSE IF regTab [reg] <> free THEN BEGIN(* conflict *)
    pReg := regTab [reg];
    ASSERT (pReg >= 0);
    OPLGetReg (r);
    regTab [r] := pReg;
    INC (r, (_SYSTEM._MOD(InstrTab[pReg].op,8)) * 8);
    InstrTab [pReg].reg := r; (* Instr [regTab [reg]].reg = new register *)
    OPOi386.GenMOV (RegReg, r, reg, noInx, noScale, noDisp, noImm)
  END;
  regTab [reg] := Occupied
END;

PROCEDURE AddLink (index, offset: LONGINT);
VAR
  old: LONGINT;
BEGIN
  IF NOT LinkErr THEN BEGIN
    OPOi386.GetDWord (offset, old);
    IF link [index].offset = aNil THEN
      OPOi386.PutDWordAt (offset, -$10000 + _SYSTEM._MOD(old ,$10000))
    ELSE BEGIN
      IF link [index].offset >= $8000 THEN
        OPOi386.PutDWordAt (offset, (link [index].offset -$10000) * $10000 + _SYSTEM._MOD(old,$10000))
      ELSE
        OPOi386.PutDWordAt (offset, link [index].offset * $10000 + _SYSTEM._MOD(old,$10000));
    END;
    link [index].offset := offset
  END
END;

PROCEDURE DecCheckReg (pReg: LONGINT; src, base, inx: SHORTINT);
VAR
  reg, r: SHORTINT;
		
  PROCEDURE ReleaseReg (reg: SHORTINT);
  VAR
    pReg: LONGINT;
  BEGIN
    IF reg > none THEN BEGIN
      IF reg >= AL THEN
        pReg := sregTab [reg-AL]
      ELSE
        pReg := regTab [_SYSTEM._MOD(reg,8)];
      IF pReg > none THEN InstrTab [pReg].reg := -2-reg;
    END
  END;

  PROCEDURE CheckRegister (reg, src: SHORTINT);
  VAR
    s: SHORTINT;
  BEGIN
    IF src IN [AL..BH] THEN
      s := _SYSTEM._MOD(src,4)
    ELSE
      s := _SYSTEM._MOD(src,8);
    IF reg IN [AL..BH] THEN BEGIN
      IF src IN [AL..BH] THEN BEGIN
        IF reg = src THEN
          ReleaseReg (src)
        ELSE
          DecReg (src);
      END ELSE IF _SYSTEM._MOD(reg,4) = s THEN
        ReleaseReg (src)
      ELSE
        DecReg (src);
    END ELSE IF _SYSTEM._MOD(reg,8) = s THEN
      ReleaseReg (src)
    ELSE
      DecReg (src);
  END;
		
BEGIN
  reg:= InstrTab[pReg].reg;
  CheckRegister (reg, src);
  CheckRegister (reg, base);
  CheckRegister (reg, inx);
  IF reg >= AL THEN BEGIN
    regTab [_SYSTEM._MOD(reg,4)] := Splitted;
    sregTab [reg - AL] := pReg
  END ELSE IF (reg <> none) AND NOT(reg IN [ESP, EBP, SP, BP]) THEN BEGIN
    r := _SYSTEM._MOD(reg ,8);
    regTab [r] := pReg;
    IF reg IN SplittableReg THEN BEGIN
      sregTab [r] := free;
      sregTab [r+4] := free
    END
  END
END;

PROCEDURE FVarConsLink (index, offset: LONGINT);
VAR
  i: LONGINT;
  vvar: VarConsLinkTable;
BEGIN
  IF nofVarConsLinks >= LENGTH(varConsTab) THEN BEGIN
    SETLENGTH(vvar, LENGTH(varConsTab)*2);
    FOR i := 0 TO LENGTH(varConsTab)-1 DO vvar[i] := varConsTab[i];
    varConsTab := vvar
  END;
  INC (varConsLink[index].noflinks);
  IF varConsLink[index].noflinks = 1 THEN
    varConsLink[index].index := nofVarConsLinks
  ELSE BEGIN
    index := varConsLink[index].index;
    WHILE varConsTab[index].next <> noEntry DO index := varConsTab[index].next;
    varConsTab[index].next := nofVarConsLinks
  END;
  varConsTab[nofVarConsLinks].offset := offset;
  varConsTab[nofVarConsLinks].next := noEntry;
  INC (nofVarConsLinks)
END;

PROCEDURE AbsAccess (node: OPT.Nodes; offset: LONGINT);
BEGIN
  IF OPM.noerr THEN BEGIN
    IF (node <> NIL) AND (node.link = NIL) AND (node.obj = NIL)
    AND (node.left = NIL) AND (node.right = NIL) THEN
      FVarConsLink (0, offset)
    ELSE BEGIN
      WHILE (node <> NIL) AND (node.left <> NIL) DO node := node.left;
      IF (node = NIL) OR (node.obj.mnolev = 0) THEN (* constant, variable in the compiled module *)
        FVarConsLink (0, offset)
      ELSE
        FVarConsLink (_SYSTEM._DIV(node.obj.adr,$10000), offset);
    END
  END
END;

PROCEDURE OPLStore (VAR instr: Instruction);
VAR
  mode, scale, size, reg, base, inx: SHORTINT;
  disp, delta: LONGINT;
BEGIN
  FindMemReg (instr, mode, scale, size, base, inx, disp);
  IF instr.op DIV 32 = sGETreg THEN BEGIN
    OPOi386.GenMOV (mode,instr.hint + size, base, inx, scale, disp, noImm);
    reg := none;
    delta := 0
  END ELSE IF NOT loaded (instr.dest) AND ( _SYSTEM._MOD(_SYSTEM._DIV(InstrTab [instr.dest].op,8),4) = ImmReg) THEN BEGIN
    OPOi386.GenMOV (ImmMem, size, base, inx, scale, disp, InstrTab [instr.dest].src2);
    mode := ImmMem;
    IF OPOi386.lastImmSize = Bit8 THEN
      delta := 1
    ELSE IF OPOi386.lastImmSize = Bit16 THEN
      delta := 2
    ELSE (* lastImmSize = Bit 32 *)
      delta := 4;
  END ELSE BEGIN
    delta := 0;
    FindLoadReg (instr.dest, reg);
    ASSERT (((size = Bit8) AND ((reg IN SplittableReg) OR (reg IN [AL..BH]))) OR (size <> Bit8));
    OPOi386.GenMOV (mode, _SYSTEM._MOD(reg,8) + size, base, inx, scale, disp, noImm)
  END;
  DecReg (reg);
  DecReg (base);
  DecReg (inx);
  IF (mode IN [ImmMem, RegMem, MemReg]) AND (base = noBase) AND NOT instr.abs THEN (* absolute access *)
    AbsAccess (instr.node, OPOi386.pcc - delta - 4);
END;

PROCEDURE GenPush (VAR instr: Instruction);
VAR
  reg, i: SHORTINT;
BEGIN
  ASSERT (_SYSTEM._MOD(_SYSTEM._DIV(instr.op,8),4) IN [Imme, Regs]);
  IF _SYSTEM._MOD(_SYSTEM._DIV(instr.op,8),4) = Imme THEN
    OPOi386.GenPUSH (Imme, Bit32, noBase, noInx, noScale, noDisp, instr.src2)
  ELSE BEGIN(* first load and then push -> faster on i486 based machines *)
    FindLoadReg (instr.src1, reg);
    IF reg IN [AH, CH, DH, BH] THEN BEGIN
      i := EBX;
      WHILE (i >= EAX) AND NOT((regTab [i] = Splitted) AND (sregTab [i] = free)) DO DEC (i);
      IF i < EAX THEN BEGIN(* none of the 8 bit registers AL, CL, DL, BL are free *)
        i := EBX;
        WHILE (i >= EAX) AND (regTab [i] <> free) DO DEC (i); (* search a splittable register *)
        IF i < EAX THEN OPLGetReg(i);
      END;
      IF i IN SplittableReg THEN BEGIN
        GetThisReg8 (i + AL);
        OPOi386.GenMOV (RegReg, i+AL, reg, noInx, noScale, noDisp, noImm);
        OPOi386.GenPUSH (Regs, i, noBase, noInx, noScale, noDisp, noImm)
      END ELSE BEGIN(* move sign extended *)
        OPOi386.GenMOVSX (Regs, 0, i, reg, noInx, noScale, noDisp);
        OPOi386.GenPUSH (Regs, i, noBase, noInx, noScale, noDisp, noImm)
      END;
      FreeReg (i)
    END ELSE BEGIN
      IF reg IN [AL, CL, DL, BL] THEN
        i := _SYSTEM._MOD(reg,4) (* we can't push a byte *)
      ELSE
        i := _SYSTEM._MOD(reg,8); (* only push 32 bit register *)
      OPOi386.GenPUSH (Regs, i, noBase, noInx, noScale, noDisp, noImm)
    END;
    DecReg (reg)
  END
END;

PROCEDURE AssignNewReg (pReg: LONGINT);
VAR
  reg: SHORTINT;
  size: LONGINT;
BEGIN
  size := _SYSTEM._MOD(InstrTab [pReg].op,8);
  IF size = 2 THEN BEGIN(* Byte *)
    GetReg8 (reg);
    sregTab [reg-AL] := pReg
  END ELSE BEGIN
    OPLGetReg (reg);
    regTab [reg] := pReg;
    IF size = 1 THEN (* Word *) INC (reg, AX);
  END;
  InstrTab [pReg].reg := reg
END;

PROCEDURE AssignThisReg (pReg: LONGINT; this: SHORTINT);
BEGIN
  IF this IN [AL..BH] THEN BEGIN
    GetThisReg8 (this);
    sregTab [this-AL] := pReg
  END ELSE IF NOT(this IN [ESP, SP, EBP, BP]) THEN BEGIN
    GetThisReg (this);
    regTab [_SYSTEM._MOD(this,8)] := pReg
  END;
  InstrTab [pReg].reg := this
END;

PROCEDURE LoadProc (VAR instr: Instruction);
VAR
  dummy: SHORTINT;

  PROCEDURE AssignReg (pReg: LONGINT);
  VAR
    hint, size: LONGINT;
  BEGIN
    hint := InstrTab[pReg].hint;
    size:= _SYSTEM._MOD(InstrTab[pReg].op,8) * 8;
    IF hint >= tryEAX THEN BEGIN
      IF size = Bit8 THEN BEGIN
        IF sregTab [hint - tryEAX] = free THEN BEGIN
          AssignThisReg (pReg, hint-tryEAX+Bit8);
          EXIT;
        END
      END ELSE IF regTab [hint - tryEAX] = free THEN BEGIN
        AssignThisReg (pReg, hint - tryEAX + size);
        EXIT;
      END;
      hint:= noHint
    END;
    IF hint = noHint THEN
      AssignNewReg (instr.dest)
    ELSE BEGIN
      ASSERT (hint > noHint);
      AssignThisReg (pReg, hint + size);
    END
  END;

BEGIN (* LoadProc *)
  AssignReg (instr.dest);
  IF instr.op DIV 32 = sLdProc THEN BEGIN(* procedure in the compiled module *)
    OPOi386.GenMOV (ImmReg, instr.reg, noBase, noInx, noScale, noDisp, _SYSTEM._MOD(instr.src1,$10000));
    AddLink (LocProcAssIndex, OPOi386.pcc - 4)
  END ELSE BEGIN(* instr.op DIV 32 = LdXProc *)
    OPOi386.GenMOV (ImmReg, instr.reg, noBase, noInx, noScale, noDisp, $0FFFF);
    AddLink (_SYSTEM._MOD(instr.src1,$10000), OPOi386.pcc - 4)
  END;
  dummy := none;
  DecCheckReg (instr.dest, dummy, dummy, dummy)
END;

PROCEDURE AssignReg (pReg: LONGINT; VAR reg, base, inx: SHORTINT);
VAR
  hint, size, pRegBase, pRegInx, pRegReg: LONGINT;
BEGIN
  pRegBase:=0;
  pRegInx:=0;
  pRegReg:=0;
  hint := InstrTab[pReg].hint;
  size:= _SYSTEM._MOD(InstrTab[pReg].op,8) * 8;
  
  ASSERT ((reg = none) OR ((size = Bit8) AND (reg >= AL)) OR
    ((size = Bit16) AND (reg >= AX)) OR ((size = Bit32) AND (reg >= EAX)));

  IF hint >= tryEAX THEN BEGIN
    IF size = Bit8 THEN BEGIN
      IF sregTab [hint - tryEAX] = free THEN BEGIN
        AssignThisReg (pReg, hint-tryEAX+Bit8);
        EXIT;
      END
    END ELSE IF regTab [hint - tryEAX] = free THEN BEGIN
      AssignThisReg (pReg,hint - tryEAX + size);
      EXIT;
    END;
    hint:= noHint
  END;

  IF hint <= noHint THEN BEGIN
    IF (reg = none) OR NOT LastUse(reg) THEN BEGIN
      AssignNewReg (pReg);
    END ELSE BEGIN
      InstrTab[pReg].reg := reg;
    END;
  END ELSE BEGIN
    IF reg >= AL THEN
      pRegReg := sregTab [reg - AL]
    ELSE IF reg <> none THEN
      pRegReg := regTab [_SYSTEM._MOD(reg,8)];
    IF inx >= AL THEN
      pRegInx := sregTab [inx - AL]
    ELSE IF inx <> noInx THEN
      pRegInx := regTab [_SYSTEM._MOD(inx,8)];
    IF base >= AL THEN
      pRegBase := sregTab [base - AL]
    ELSE IF base <> noBase THEN
      pRegBase := regTab [_SYSTEM._MOD(base,8)];
    AssignThisReg (pReg, hint + size);
    IF (reg <> none) AND (pRegReg >= 0) THEN reg := InstrTab [pRegReg].reg;
    IF (inx <> none) AND (pRegInx >= 0) THEN inx := InstrTab [pRegInx].reg;
    IF (base <> none) AND (pRegBase >= 0) THEN base := InstrTab [pRegBase].reg;
  END
END;

PROCEDURE GenPop (VAR instr: Instruction);
  VAR reg, dummy: SHORTINT;
BEGIN
  dummy := noBase; (* = noInx *)
  AssignReg (instr.dest, dummy, dummy, dummy);
  reg := instr.reg;
  ASSERT (((instr.op DIV 8) MOD 4 = Regs) AND NOT(reg IN [AL..BH])); (* 8 bit pop is not allowed *)
  reg := _SYSTEM._MOD(reg,8); (* only pop 32 bit register *)
  OPOi386.GenPOP(Regs, reg, noBase, noInx, noScale, noDisp);
END;

PROCEDURE Gen1 (VAR instr: Instruction; RiscPC: LONGINT);
VAR
  op, mode, scale, size, reg, base, inx: SHORTINT;
  disp: LONGINT;
BEGIN
  op := instr.op DIV 32;
  IF op = sJmpReg THEN BEGIN
    IF NOT loaded (instr.src2) THEN BEGIN
      FindMemReg (InstrTab[instr.src2], mode, scale, size, base, inx, disp);
      OPOi386.GenJMP (Mem, 0, base, inx, scale, disp);
      DecReg (base);
      DecReg (inx)
    END ELSE BEGIN
      FindReg (instr.src2, reg);
      OPOi386.GenJMP (Regs, reg, noBase, noInx, noScale, noDisp);
      DecReg (reg)
    END
  END ELSE IF op = sJmp THEN BEGIN
    IF RiscPC >= instr.src2 THEN BEGIN(* backward jump *)
      disp := InstrTab [instr.src2].pc - (OPOi386.pcc+2);
      IF disp < -128 THEN DEC (disp, 3); (* 32 bit displacement *)
      OPOi386.GenJMP (Imme, none, noBase, noInx, noScale, disp)
    END ELSE BEGIN(* link with fixup chain *)
      (* always 32 bit displacement *)
      OPOi386.GenJMP (Imme, none, noBase, noInx, noScale, -2 - InstrTab [instr.src2].pc - $10000);
      InstrTab [instr.src2].pc := RiscPC
    END;
  END ELSE BEGIN
    ASSERT ((op >= sJe) AND (op <= sJnc));
    op := JmpConvert [op-sJe];
    IF RiscPC >= instr.src2 THEN BEGIN(* backward jump *)
      disp := InstrTab [instr.src2].pc - (OPOi386.pcc+2);
      IF disp < -128 THEN DEC (disp, 4); (* 32 bit displacement *)
      OPOi386.GenJcc(op, disp)
    END ELSE BEGIN(* link with fixup chain *)
      (* always 32 bit displacement *)
      OPOi386.GenJcc (op, -2 - InstrTab [instr.src2].pc - $10000);
      InstrTab [instr.src2].pc := RiscPC
    END
  END
END;
	
PROCEDURE Gen2 (VAR instr: Instruction);
VAR
  src, dummy: SHORTINT;
BEGIN
  ASSERT ((instr.op DIV 32 = sNeg) OR (instr.op DIV 32 = sNot));
  dummy := noInx;
  FindLoadReg (instr.src1, src);
  AssignReg (instr.dest, src, dummy, dummy);
  IF instr.reg <> src THEN
    OPOi386.GenMOV (RegReg, instr.reg, src, noInx, noScale, noDisp, noImm);
  IF instr.op DIV 32 = sNeg THEN
    OPOi386.GenNEG (RegReg, instr.reg, noBase, noInx, noScale, noDisp)
  ELSE
    OPOi386.GenNOT (RegReg, instr.reg, noBase, noInx, noScale, noDisp);
  DecCheckReg (instr.dest, src, dummy, dummy)
END;
	
PROCEDURE Gen3 (VAR instr: Instruction);
VAR
  op, mode, scale, size, base, inx, src, dummy, shiftReg: SHORTINT;
  disp: LONGINT;
BEGIN
  op := instr.op DIV 32;
  mode := _SYSTEM._MOD(_SYSTEM._DIV(instr.op,8),4);
  size := _SYSTEM._MOD(instr.op,8) * 8;
  IF mode = ImmReg THEN BEGIN
    FindLoadReg (instr.src1, src);
    base := noBase;
    inx := noInx;
    scale := noScale;
    disp := noDisp
  END ELSE IF  NOT loaded (instr.src1) THEN BEGIN
    IF  NOT loaded (instr.src2) THEN BEGIN
      FindLoadReg (instr.src1, src);
      FindMemReg (InstrTab [instr.src2], dummy, scale, dummy, base, inx, disp);
      mode := MemReg
    END ELSE IF ((op = sAdd) OR (op = soR) OR (op = sXor) OR (op = sAnd)) THEN BEGIN
      FindReg (instr.src2, src);
      FindMemReg (InstrTab [instr.src1], dummy, scale, dummy, base, inx, disp);
      mode := MemReg
    END ELSE BEGIN
      FindLoadReg (instr.src1, src);
      FindReg (instr.src2, base); inx := none; scale := noScale; disp := noDisp;
      mode := RegReg
    END;
  END ELSE IF NOT loaded (instr.src2) THEN BEGIN
    mode := MemReg;
    FindReg (instr.src1, src);
    FindMemReg (InstrTab [instr.src2], dummy, scale, dummy, base, inx, disp)
  END ELSE BEGIN
    mode := RegReg;
    FindReg (instr.src1, src);
    FindReg (instr.src2, base);
    inx := noInx;
    scale := noScale;
    disp := noDisp
  END;
  src := src MOD 8 + size;			(* bug fix *)
  AssignReg (instr.dest, src, base, inx);
  IF instr.reg <> src THEN
    OPOi386.GenMOV (RegReg, instr.reg, src, noInx, noScale, noDisp, noImm);
  IF op <= sAnd THEN BEGIN(* !!later: optimize add, 1 -> INC, sub, 1 -> DEC *)
    CASE op OF
      sAdd: op := BADD;
      sSub: op := BSUB;
      soR : op := BOr;
      sXor: op := BXOR;
      sAnd: op := BAND;
    ELSE HALT (BUG)
    END;
    OPOi386.GenTyp1 (op, mode, instr.reg, base, inx, scale, disp, instr.src2)
  END ELSE IF op = sBts THEN
    OPOi386.GenBTS (mode, instr.reg, base, inx, scale, disp, instr.src2)
  ELSE IF op = sBtr THEN
    OPOi386.GenBTR (mode, instr.reg, base, inx, scale, disp, instr.src2)
  ELSE BEGIN(* op <= Rol *)
    ASSERT (op <= sRol);
    IF (mode = RegReg) AND NOT(base IN [ECX, CX, CL]) THEN BEGIN
      shiftReg := ECX + _SYSTEM._DIV(base,8) * 8;
      AssignThisReg (instr.src2, shiftReg);
      OPOi386.GenMOV (RegReg, shiftReg, base, noInx, noScale, noDisp, noImm);
      IF base IN [AL..BH] THEN BEGIN
        sregTab [base-AL] := Occupied;
        FreeReg (base)
      END ELSE
        regTab [_SYSTEM._MOD(base,8)] := free;
      base := shiftReg
    END;
    CASE op OF
      sSal: op := BSAL;
      sSar: op := BSAR;
      sShr: op := BSHR;
      sRol: op := BROL;
    ELSE
      HALT (BUG)
    END;
    OPOi386.GenShiftRot (op, mode, instr.reg, base, inx, scale, disp, instr.src2)
  END;
  DecCheckReg (instr.dest, src, base, inx)
END;

PROCEDURE GenDivMod (VAR instr: Instruction);
VAR
  size, mode, src, base, inx, scale, dummy: SHORTINT;
  disp, pRegBase, pRegInx: LONGINT;
BEGIN
  pRegBase:=0;
  pRegInx:=0;
  size := _SYSTEM._MOD(instr.op,8) * 8;
  mode := _SYSTEM._MOD(_SYSTEM._DIV(instr.op,8),4);
  IF (size <> Bit8) AND (regTab [EDX] = free) THEN regTab [EDX] := Occupied; (* reserve EDX *)
  IF mode <> ImmReg THEN BEGIN
    IF loaded (instr.src2) THEN BEGIN
      FindReg (instr.src2, base);
      inx := noInx;
      scale := noScale;
      disp := noDisp
    END ELSE BEGIN
      mode := MemReg;
      FindMemReg (InstrTab[instr.src2], dummy, scale, dummy, base, inx, disp)
    END
  END ELSE BEGIN
    inx := noInx;
    base := noBase
  END;
  IF NOT loaded (instr.src1) THEN BEGIN
    InstrTab [instr.src1].hint := useEAX;
    FindLoadReg (instr.src1, src)
  END ELSE
    FindReg (instr.src1, src);
  IF base >= AL THEN
    pRegBase := sregTab [base-AL]
  ELSE IF base <> none THEN
    pRegBase := regTab [_SYSTEM._MOD(base,8)];
  IF inx <> none THEN BEGIN
    ASSERT (inx IN [EAX..EDI]);
    pRegInx := regTab [inx]
  END;
  IF size = Bit8 THEN BEGIN
    IF LastUse (src) AND (src IN [AL, AH]) THEN BEGIN
      IF src = AL THEN
        GetThisReg8 (AH)
      ELSE
        GetThisReg8 (AL);
      regTab [EAX] := Occupied
    END ELSE
      GetThisReg (EAX);
    OPOi386.GenMOVSX (RegReg, 0, AX, src, noInx, noScale, noDisp);
    IF LastUse (src) THEN BEGIN
      FreeReg (src);
      src := none
    END;
    IF mode = ImmReg THEN BEGIN(* immediate division not allowed *)
      mode := RegReg;
      inx := noInx;
      scale := noScale;
      disp := noDisp;
      GetReg8 (base);
      OPOi386.GenMOV (ImmReg, base, noBase, noInx, noScale, noDisp, instr.src2)
    END
  END ELSE BEGIN (* Bit16 / Bit32 *)
    IF NOT LastUse (src) AND (src IN [EAX, AX]) THEN BEGIN(* conflict *)
      AssignNewReg (instr.src1);
      src := InstrTab [instr.src1].reg;
      OPOi386.GenMOV (RegReg, src, EAX, noInx, noScale, noDisp, noImm);
      regTab [EAX] := Occupied
    END ELSE IF NOT(src IN [EAX, AX]) THEN BEGIN
      GetThisReg (EAX);
      OPOi386.GenMOV (RegReg, EAX+size, src, noInx, noScale, noDisp, noImm);
      IF LastUse (src) THEN BEGIN
        FreeReg (src);
        src := none
      END
    END ELSE BEGIN
      FreeReg (src);
      src := none;
      regTab [EAX] := Occupied
    END;
    IF regTab [EDX] <> Occupied THEN GetThisReg (EDX);
    IF mode = ImmReg THEN BEGIN(* immediate division not allowed *)
      OPLGetReg (base);
      INC (base, size);
      inx := noInx;
      OPOi386.GenMOV (ImmReg, base, noBase, noInx, noScale, noDisp, instr.src2);
      mode := RegReg
    END;
    OPOi386.Prefix (size, dummy); OPOi386.PutByte (BCWD);
  END;
  IF (base <> none) AND (_SYSTEM._MOD(_SYSTEM._DIV(instr.op,8),4) <> ImmReg) THEN base := InstrTab [pRegBase].reg;
  IF inx <> none THEN inx := InstrTab [pRegInx].reg;
  IF mode = RegReg THEN
    OPOi386.GenIDIV (RegReg, base, noBase, noInx, noScale, noDisp)
  ELSE
    OPOi386.GenIDIV (mode, size, base, inx, scale, disp);
  IF (size = Bit8) THEN
    OPOi386.GenTyp1 (BCMP, ImmReg, AH, noBase, noInx, noScale, noDisp, 0)
  ELSE
    OPOi386.GenTyp1 (BCMP, ImmReg, EDX+size, noBase, noInx, noScale, noDisp, 0);
  IF instr.op DIV 32 = sDiv THEN BEGIN
    IF size = Bit32 THEN
      OPOi386.GenJcc (JGE, 1)
    ELSE
      OPOi386.GenJcc (JGE, 2);
    OPOi386.GenDEC (ImmReg, EAX+size, noBase, noInx, noScale, noDisp);
    instr.reg := EAX+size;
    IF size = Bit8 THEN BEGIN
      regTab [EAX] := Splitted;
      sregTab [AL-AL] := instr.dest;
      sregTab [AH-AL] := free
    END ELSE BEGIN
      regTab [EAX] := instr.dest;
      FreeReg (EDX)
    END
  END ELSE BEGIN(* MOD *)
    ASSERT (instr.op DIV 32 = sMod);
    IF size = Bit16 THEN
      OPOi386.GenJcc (JGE, 3)
    ELSE
      OPOi386.GenJcc (JGE, 2);
    IF (size = Bit8) THEN BEGIN
      OPOi386.GenTyp1 (BADD, mode, AH, base, inx, scale, disp, noImm);
      instr.reg := AH;
      regTab [EAX] := Splitted;
      sregTab [AH-AL] := instr.dest;
      sregTab [AL-AL] := free
    END ELSE BEGIN
      OPOi386.GenTyp1 (BADD, mode, EDX+size, base, inx, scale, disp, noImm);
      instr.reg := EDX+size;
      regTab [EDX] := instr.dest;
      FreeReg (EAX)
    END
  END;
  IF _SYSTEM._MOD(_SYSTEM._DIV(instr.op,8),4) = ImmReg THEN BEGIN
    FreeReg (base);
    base := none
  END;
  DecCheckReg (instr.dest, src, base, inx);
  IF (instr.hint IN useReg) AND (_SYSTEM._MOD(instr.reg,8) <> instr.hint) THEN BEGIN(* result is in the wrong register *)
    src := instr.reg;
    AssignThisReg (instr.dest, instr.hint + size);
    OPOi386.GenMOV (RegReg, instr.reg, src, noInx, noScale, noDisp, noImm);
    FreeReg (src);
  END
END;
	
PROCEDURE GenMul (VAR instr: Instruction);
VAR
  size, mode, src, base, inx, scale, dummy:  SHORTINT;
  disp, pRegBase, pRegInx: LONGINT;
BEGIN
  pRegBase:=0;
  pRegInx:=0;
  size := _SYSTEM._MOD(instr.op,8) * 8;
  mode := _SYSTEM._MOD(_SYSTEM._DIV(instr.op,8),4);
  IF mode <> ImmReg THEN BEGIN
    IF loaded (instr.src2) THEN BEGIN
      FindReg (instr.src2, base);
      inx := noInx;
      scale := noScale;
      disp := noDisp
    END ELSE BEGIN
      mode := RegMem;
      FindMemReg (InstrTab [instr.src2], dummy, scale, dummy, base, inx, disp)
    END
  END;
  IF NOT loaded (instr.src1) THEN BEGIN
    IF size = Bit8 THEN InstrTab [instr.src1].hint := useEAX;
    FindLoadReg (instr.src1, src)
  END ELSE
    FindReg (instr.src1, src);
  IF (mode = ImmReg) AND (size <> Bit8) THEN BEGIN(* imul reg, src, immediate *)
    inx := none;
    base := none;
    AssignReg (instr.dest, src, base, inx);
    OPOi386.GenIMUL (ImmReg, FALSE, instr.reg(*+size*), src, noInx, noScale, noDisp, instr.src2)		(* mul bug *)
  END ELSE BEGIN
    IF size = Bit8 THEN BEGIN(* imul reg/mem *)
      IF mode <> ImmReg THEN BEGIN
        IF base >= AL THEN
          pRegBase := sregTab [base - AL]
        ELSE IF base <> none THEN
          pRegBase := regTab [_SYSTEM._MOD(base,8)];
        IF inx <> none THEN BEGIN
          ASSERT (inx < AL);
          pRegInx := regTab [_SYSTEM._MOD(inx,8)] 
        END
      END;
      IF LastUse (src) AND (src IN [AL, AH]) THEN BEGIN
        IF src = AL THEN BEGIN
          IF NOT((mode = RegReg) AND LastUse (base)) THEN GetThisReg8 (AH);
        END ELSE BEGIN
          GetThisReg8 (AL);
          OPOi386.GenMOV (RegReg, AL, src, noInx, noScale, noDisp, noImm)
        END
      END ELSE BEGIN
        GetThisReg (EAX);
        src := InstrTab [instr.src1].reg;
        OPOi386.GenMOV (RegReg, AL, src, noInx, noScale, noDisp, noImm)
      END;
      IF LastUse (src) THEN BEGIN
        FreeReg (src);
        src:= none
      END;
      instr.reg := AL;
      regTab [EAX] := Splitted;
      sregTab [AL-AL] := instr.dest;
      sregTab [AH - AL] := free;
      IF mode = ImmReg THEN BEGIN(* immediate mul not allowed *)
        mode := RegReg;
        GetReg8 (base);
        inx := noInx;
        scale := noScale;
        disp := noDisp;
        OPOi386.GenMOV (ImmReg, base, noBase, noInx, noScale, noDisp, instr.src2);
        OPOi386.GenIMUL (mode, TRUE, instr.reg, base, inx, scale, disp, noImm);
        FreeReg (base);
        base := none
      END ELSE BEGIN
        IF base <> none THEN base := InstrTab [pRegBase].reg;
        IF inx <> none THEN inx := InstrTab [pRegInx].reg;
        OPOi386.GenIMUL (mode, TRUE, instr.reg, base, inx, scale, disp, noImm)
      END;
    END ELSE BEGIN
      ASSERT (size IN [Bit16, Bit32]);
      AssignReg (instr.dest, src, base, inx);
      IF instr.reg <> src THEN OPOi386.GenMOV (RegReg, instr.reg, src, noInx, noScale, noDisp, noImm);
      IF (instr.reg IN [AX, EAX]) AND (regTab [EDX] = free) THEN (* use short form *)
        OPOi386.GenIMUL (mode, TRUE, instr.reg, base, inx, scale, disp, noImm)
      ELSE
        OPOi386.GenIMUL (mode, FALSE, instr.reg, base, inx, scale, disp, noImm);
    END
  END;
  DecCheckReg (instr.dest, src, base, inx)
END;
	
PROCEDURE GenRepMovs (VAR instr: Instruction);
VAR
  src, dest, nofElem, tmp: SHORTINT;
BEGIN
  FindLoadReg (instr.dest, dest);
  ASSERT (dest IN [EAX..EDI]);
  IF dest <> EDI THEN BEGIN
    IF instr.dest >= 0 THEN
      AssignThisReg (instr.dest, EDI)
    ELSE
      GetThisReg (EDI);
    OPOi386.GenMOV (RegReg, EDI, dest, noInx, noScale, noDisp, noImm);
    IF NOT(dest IN [ESP, EBP]) THEN regTab [dest] := free;
  END;
  FindLoadReg (instr.src1, src);
  ASSERT (src IN [EAX..EDI]);
  IF src <> ESI THEN BEGIN
    IF instr.src1 >= 0 THEN
      AssignThisReg (instr.src1, ESI)
    ELSE
      GetThisReg (ESI);
    OPOi386.GenMOV (RegReg, ESI, src, noInx, noScale, noDisp, noImm);
    IF NOT(src IN [ESP, EBP]) THEN regTab [src] := free;
  END;
  FindLoadReg (instr.src2, nofElem);
  ASSERT (nofElem IN [EAX..EDI]);
  IF nofElem <> ECX THEN BEGIN
    IF instr.src2 >= 0 THEN
      AssignThisReg (instr.src2, ECX)
    ELSE
      GetThisReg (ECX);
    OPOi386.GenMOV (RegReg, ECX, nofElem, noInx, noScale, noDisp, noImm);
    IF NOT(nofElem IN [ESP, EBP]) THEN regTab [nofElem] := free;
  END;
  IF (instr.inx = AL) AND (instr.hint = noHint) THEN BEGIN(*8-bit move, forward move*)
    GetReg8(tmp);
    OPOi386.GenMOV(RegReg, tmp, CL, noInx, noScale, noDisp, noImm);
    OPOi386.GenShiftRot(BSHR, ImmReg, ECX, noBase, noInx, noScale, noDisp, 2);
    OPOi386.GenTyp1(BAND, ImmReg, tmp, noBase, noInx, noScale, noDisp, 3);
    OPOi386.GenRepString(BMOVS, EAX);
    OPOi386.GenMOV(RegReg, CL, tmp, noInx, noScale, noDisp, noImm);
    OPOi386.GenRepString(BMOVS, AL);
    FreeReg(tmp)
  END ELSE
    OPOi386.GenRepString (BMOVS, instr.inx);
  IF regTab [ECX] = Occupied THEN
    FreeReg (ECX)
  ELSE
    DecReg (ECX); (* nofElem *)
  IF regTab [ESI] = Occupied THEN
    FreeReg (ESI)
  ELSE
    DecReg (ESI); (* src *)
  IF regTab [EDI] = Occupied THEN
    FreeReg (EDI)
  ELSE
    DecReg (EDI); (* dest *)
END;
					
PROCEDURE GenCmpString (VAR instr: Instruction);
VAR
  src, srcAdr, src2Adr: SHORTINT;
  Lfix, L0, L1: LONGINT;
BEGIN
  Lfix := OPOi386.pcc;
  FindLoadReg (instr.src1, srcAdr);
  FindLoadReg (instr.src2, src2Adr);
  GetReg8 (src);
  OPOi386.GenMOV (MemReg, src, srcAdr, noInx, noScale, 0, noImm);
  OPOi386.GenTyp1 (BCMP, MemReg, src, src2Adr, noInx, noScale, 0, noImm);
  OPOi386.GenJcc (JNE, 0);
  L0 := OPOi386.pcc-1;
  OPOi386.GenTyp1 (BCMP, ImmReg, src, noBase, noInx, noScale, noDisp, 0);
  OPOi386.GenJcc (JE, 0);
  L1 := OPOi386.pcc-1;
  OPOi386.GenINC (ImmReg, srcAdr, noBase, noInx, noScale, noDisp);
  OPOi386.GenINC (ImmReg, src2Adr, noBase, noInx, noScale, noDisp);
  OPOi386.GenJMP (Imme, none, noBase, noInx, noScale, Lfix - (OPOi386.pcc + 2));
  OPOi386.PutByteAt (L0, OPOi386.pcc - (L0+1));
  OPOi386.PutByteAt (L1, OPOi386.pcc - (L1+1));
  FreeReg (src);
  DecReg (srcAdr);
  DecReg (src2Adr)
END;

PROCEDURE Setcc (VAR instr: Instruction);
VAR
  dummy: SHORTINT;
BEGIN
  dummy := none;
  AssignReg (instr.dest, dummy, dummy, dummy);
  OPOi386.GenSetcc (SetccConvert [_SYSTEM._DIV(instr.op,32) - sSete], Regs, instr.reg, noInx, noScale, noDisp)
END;

PROCEDURE GenTrap (trapNr: LONGINT);
BEGIN
  OPOi386.GenPUSH(Imme, 0, noBase, noInx, noScale, noDisp, trapNr);	(* PUSH TrapNr *)
  OPOi386.PutByte($0CC);		(* INT 3 *)
END;
	
PROCEDURE GenIntpt (Instr: Instruction);
BEGIN
  OPOi386.PutByte($0CD);
  OPOi386.PutByte(Instr.src2);
  FreeReg(EAX);
  FreeReg(EBX);
  FreeReg(ECX);
  FreeReg(EDX)
END;

PROCEDURE GenTrapCC (VAR instr: Instruction);
VAR
  op: SHORTINT;
BEGIN
  op:=0;
  IF instr.op DIV 32 = sTo THEN
    OPOi386.PutByte ($0CE)
  ELSE BEGIN
    CASE instr.op DIV 32 OF
      sTe : op := JNE;
      sTne: op := JE;
      sTle: op := JNLE;
      sTa : op := JNA;
      sTae: op := JNAE;
    ELSE
      HALT (BUG)
    END;
    OPOi386.GenJcc (op, 3);
    OPOi386.GenPUSH(Imme, 0, noBase, noInx, noScale, noDisp, instr.src2);	(* PUSH TrapNr *)
    OPOi386.PutByte($0CC);		(* INT 3 *)
  END;
END;
	
PROCEDURE FixupAndGenTrap;
VAR
  i, fixuppos, pos, next: LONGINT;
BEGIN
  i := 0;
  WHILE i < nofTrapFixups DO BEGIN
    IF trapFixupTab [i] <> aNil THEN BEGIN
      fixuppos := OPOi386.pcc;
      pos := trapFixupTab [i];
      REPEAT
        OPOi386.GetDWord (pos, next);
        OPOi386.PutDWordAt (pos, fixuppos - (pos + 4));
        pos := -2 - next - $10000;
      UNTIL pos = aNil;
      GenTrap (i)
    END;
    INC (i)
  END
END;

PROCEDURE GenShort (VAR instr: Instruction);
VAR
  src, reg, hint: SHORTINT;
BEGIN
  FindReg (instr.src1, src);
  hint := instr.hint;
  ASSERT (LastUse (src));
  IF _SYSTEM._MOD(instr.op,8) * 8 = Bit16 THEN BEGIN
    ASSERT (src IN [EAX..EDI]);
    IF (hint IN useReg) AND (src <> hint) THEN BEGIN
      AssignThisReg (instr.dest, hint + AX);
      OPOi386.GenMOV (RegReg, instr.reg, src, noInx, noScale, noDisp, noImm);
      FreeReg (src)
    END ELSE BEGIN
      FreeReg (src);
      AssignThisReg (instr.dest, src + AX)
    END;
  END ELSE BEGIN
    ASSERT (((instr.op MOD 8) * 8 = Bit8) AND (src IN [EAX..DI]));
    IF (hint IN useReg) AND (_SYSTEM._MOD(src,8) <> hint) THEN BEGIN
      ASSERT (hint IN [EAX, ECX, EDX, EBX]);
      AssignThisReg (instr.dest, hint + AL);
      IF src IN SplittableReg THEN 
        OPOi386.GenMOV (RegReg, instr.reg, _SYSTEM._MOD(src,8) + AL, noInx, noScale, noDisp, noImm)
      ELSE BEGIN(* 16/32 bit register must be copied *)
        GetThisReg8 (instr.reg + 4); FreeReg (instr.reg + 4);
        OPOi386.GenMOV (RegReg, _SYSTEM._MOD(instr.reg,4), src, noInx, noScale, noDisp, noImm)
      END;
      FreeReg (src) 
    END ELSE IF src IN SplittableReg THEN BEGIN
      FreeReg (src);
      AssignThisReg (instr.dest, _SYSTEM._MOD(src,8) + AL)
    END ELSE BEGIN
      GetSplittableReg (reg);
      OPOi386.GenMOV (RegReg, reg, src, noInx, noScale, noDisp, noImm);
      FreeReg (src); FreeReg (reg);
      AssignThisReg (instr.dest, _SYSTEM._MOD(reg,8) + AL)
    END;
  END;
END;
		
PROCEDURE GenPhi (VAR instr: Instruction);
  VAR src1, src2: SHORTINT;
BEGIN
  ASSERT ((InstrTab [instr.src2].reg >= 0) AND (InstrTab [instr.src1].reg <> none));
  IF InstrTab [instr.src1].reg < 0 THEN
    src1 := -2 - InstrTab [instr.src1].reg
  ELSE BEGIN
    src1 := InstrTab [instr.src1].reg;
    FreeReg (src1)
  END;
  src2 := InstrTab [instr.src2].reg;
  IF src1 <> src2 THEN BEGIN(* src1, src2 must be the same register *)
    AssignThisReg (instr.src2, src1); 
    OPOi386.GenMOV (RegReg, src1, src2, noInx, noScale, noDisp, noImm);
    IF src2 >= AL THEN BEGIN
      DEC (src2, AL);
      sregTab [src2] := free;
      IF src2 < 4 THEN BEGIN
        IF sregTab [src2 + 4] = free THEN regTab [src2] := free;
      END ELSE IF sregTab [src2 - 4] = free THEN
        regTab [_SYSTEM._MOD(src2,4)] := free;
    END ELSE
      regTab [_SYSTEM._MOD(src2,8)] := free;
  END
END;

(* i387 Register *)

PROCEDURE GetFreg (VAR freg: SHORTINT);
(* returns any free floating point register *)
BEGIN
  ftop := _SYSTEM._MOD((ftop -1),8);
  IF fregTab [ftop] <> free THEN BEGIN
    OPM.err (216);
    RegErr := TRUE;
    freg := ftop;
    EXIT;
  END;
  fregTab [ftop] := Occupied;
  freg := ftop
END;
	
PROCEDURE FreeFreg (freg: SHORTINT);
BEGIN
  IF freg > none THEN BEGIN
    IF fregTab [freg] > free THEN InstrTab [fregTab [freg]].reg := -2-freg;
    fregTab [freg] := free;
    IF freg = ftop THEN BEGIN
      ftop := _SYSTEM._MOD((ftop + 1),8);
      WHILE (FreeRegDisp > 0) AND (fregTab [ftop] = free) DO BEGIN
        ftop := _SYSTEM._MOD((ftop + 1),8);
        DEC (FreeRegDisp)
      END
    END ELSE BEGIN
      OPOi386.GenFFREE (_SYSTEM._MOD((freg-ftop),8));
      INC (FreeRegDisp)
    END
  END
END;

PROCEDURE ReleaseFreg (freg: SHORTINT);
BEGIN
  IF freg > none THEN BEGIN
    IF fregTab [freg] > free THEN InstrTab [fregTab [freg]].reg := -2-freg;
    fregTab [freg] := free;
    ftop := _SYSTEM._MOD((ftop + 1),8);
  END
END;

PROCEDURE AssignFreg (pReg: LONGINT);
VAR
  freg: SHORTINT;
BEGIN
  GetFreg (freg);
  fregTab [freg] := pReg;
  InstrTab [pReg].reg := freg
END;
	
PROCEDURE TakeFreg (pReg: LONGINT; freg: SHORTINT);
BEGIN
  ASSERT (fregTab[freg] = free);
  fregTab [freg] := pReg;
  InstrTab [pReg].reg := freg
END;
	
PROCEDURE FindFreg (pReg: LONGINT; VAR freg: SHORTINT);
BEGIN
  ASSERT ((pReg >= 0) AND (InstrTab [pReg].reg >= 0));
  freg := InstrTab [pReg].reg;
END;
	
FUNCTION LastUseF (freg: SHORTINT): BOOLEAN;
BEGIN
  ASSERT ((freg IN [0..7]) AND (fregTab [freg] >= 0));
  RESULT:= InstrTab[fregTab [freg]].used = 1;
END;
	
PROCEDURE DecCheckFreg (freg: SHORTINT);
VAR
  pReg: LONGINT;
BEGIN
  IF freg > none THEN BEGIN
    pReg := fregTab [freg];
    DEC (InstrTab [pReg].used);
    IF InstrTab [pReg].used = 0 THEN FreeFreg (freg);
  END
END;

PROCEDURE GenAbs (VAR instr: Instruction);
VAR
  size, src, reg, dummy: SHORTINT;
BEGIN
  size := _SYSTEM._MOD(instr.op,8) * 8;
  FindLoadReg (instr.src1, src);
  IF size = Bit8 THEN BEGIN
    IF instr.hint IN useReg THEN BEGIN
      IF LastUse (src) AND (_SYSTEM._MOD(src,4) = instr.hint) THEN BEGIN
        IF src IN [AL, CL, DL, BL] THEN
          GetThisReg8 (src + 4)
        ELSE
          GetThisReg8 (src - 4);
        reg := _SYSTEM._MOD(src,4)
      END ELSE BEGIN
        reg := instr.hint;
        GetThisReg (reg)
      END
    END ELSE BEGIN
      IF (instr.hint IN tryReg) AND (regTab [instr.hint - tryEAX] = free) THEN
        reg:= instr.hint - tryEAX
      ELSE BEGIN
        reg := EBX;
        WHILE (reg >= EAX) AND (regTab [reg] <> free) DO DEC (reg);
        IF LastUse (src) AND (((src IN [AL, CL, DL, BL]) AND (sregTab [src - AL + 4] = free)) OR
           ((src IN [AH, CH, DH, BH]) AND (sregTab [src+AL-4] = free))) THEN
          reg := _SYSTEM._MOD(src,4)
        ELSE IF reg < EAX THEN
          GetSplittableReg (reg)
      END
    END;
    OPOi386.GenMOVSX (RegReg, 0, reg, src, noInx, noScale, noDisp);
    IF LastUse (src) THEN FreeReg (src); src:= none;
    regTab [reg] := Splitted;
    sregTab [reg] := instr.dest;
    sregTab [reg + 4] := free;
    INC (reg, AL);
    instr.reg := reg;
    OPOi386.GenTyp1 (BXOR, RegReg, reg, reg + 4, noInx, noScale, noDisp, noImm);
    OPOi386.GenTyp1 (BSUB, RegReg, reg, reg + 4, noInx, noScale, noDisp, noImm)
  END ELSE BEGIN(* Bit16 / Bit32 *)
    IF regTab [OPOi386.EDX] = free THEN regTab [OPOi386.EDX] := Occupied;
    IF NOT LastUse (src) AND (src IN [EAX, AX]) THEN BEGIN(* conflict *)
      AssignNewReg (instr.src1);
      regTab [EAX] := Occupied;
      OPOi386.GenMOV (RegReg, InstrTab [instr.src1].reg, EAX, noInx, noScale, noDisp, noImm)
    END ELSE IF NOT(src IN [EAX, AX]) THEN BEGIN
      GetThisReg (EAX);
      OPOi386.GenMOV (RegReg, EAX, src, noInx, noScale, noDisp, noImm);
      IF LastUse (src) THEN BEGIN
        FreeReg (src);
        src := none;
      END
    END ELSE BEGIN
      FreeReg (src);
      src := none;
      GetThisReg (EAX)
    END;
    instr.reg := EAX + size;
    regTab [EAX] := instr.dest;
    IF regTab [EDX] <> Occupied THEN GetThisReg (EDX);
    OPOi386.Prefix (size, dummy);
    OPOi386.PutByte (BCWD);
    OPOi386.GenTyp1 (BXOR, RegReg, EAX + size, EDX + size, noInx, noScale, noDisp, noImm);
    OPOi386.GenTyp1 (BSUB, RegReg, EAX + size, EDX + size, noInx, noScale, noDisp, noImm);
    FreeReg (EDX)
  END;
  DecReg (src);
  IF (instr.hint IN useReg) AND (_SYSTEM._MOD(instr.reg,8) <> instr.hint) THEN BEGIN(* result is in the wrong register *)
    src := instr.reg;
    AssignThisReg (instr.dest, instr.hint + size);
    OPOi386.GenMOV (RegReg, instr.reg, src, noInx, noScale, noDisp, noImm);
    FreeReg (src)
  END
END;

PROCEDURE Flags (VAR instr: Instruction);
(* cmp, bt *)
  VAR
    op, mode, scale, size, base, inx, reg, dummy: SHORTINT;
    disp: LONGINT;
BEGIN
  op := instr.op DIV 32;
  mode := _SYSTEM._MOD(_SYSTEM._DIV(instr.op,8),4);
  size := _SYSTEM._MOD(instr.op,8) * 8;
  IF mode <> ImmReg THEN BEGIN
    IF NOT loaded (instr.src1) THEN BEGIN
      IF NOT loaded (instr.src2) THEN BEGIN
        FindLoadReg (instr.src1, reg);
        FindMemReg (InstrTab [instr.src2], dummy, scale, dummy, base, inx, disp);
        mode := MemReg
      END ELSE BEGIN
        FindReg (instr.src2, reg);
        FindMemReg (InstrTab [instr.src1], dummy, scale, dummy, base, inx, disp);
        mode := RegMem
      END
    END ELSE BEGIN
      FindReg (instr.src1, reg);
      IF NOT loaded (instr.src2) THEN BEGIN
        FindMemReg (InstrTab [instr.src2], dummy, scale, dummy, base, inx, disp);
        mode := RegMem
      END ELSE BEGIN
        FindReg (instr.src2, base);
        inx := noInx;
        disp := noDisp;
        mode := RegReg
      END
    END
  END ELSE IF NOT loaded (instr.src1) THEN BEGIN
    FindMemReg (InstrTab [instr.src1], dummy, scale, dummy, base, inx, disp);
    reg := size;
    mode := ImmMem
  END ELSE BEGIN
    FindReg (instr.src1, reg);
    base := noBase;
    inx := noInx;
    disp := noDisp
  END;
  IF op = sCmp THEN
    OPOi386.GenTyp1 (BCMP, mode, reg, base, inx, scale, disp, instr.src2)
  ELSE IF op = sTest THEN
    OPOi386.GenTEST (mode, reg, base, inx, scale, disp, instr.src2)
  ELSE
    OPOi386.GenBT (mode, reg, base, inx, scale, disp, instr.src2);
  DecReg (reg);
  DecReg (base);
  DecReg (inx)
END;

PROCEDURE EncodeFixup (i: LONGINT);
VAR
  L, L1: LONGINT;
  node: OPT.Nodes;
BEGIN
  node := InstrTab [i].node;
  node.left.obj.linkadr := -2 - InstrTab[i].pc - $10000;
  L := i;
  WHILE L > aNil DO BEGIN
    OPOi386.GetDWord (InstrTab[L].pc + 1, L1);
    IF (L1 > -$10000) AND (-2 - L1 > aNil) THEN BEGIN
      L1 := -2 - L1;
      OPOi386.PutDWordAt (InstrTab[L].pc + 1, -2 - InstrTab[L1].pc - $10000)
    END;
    L := L1
  END
END;

PROCEDURE GenEnter (locSize: LONGINT; locals: OPT.Objects; sysflag: SHORTINT);
VAR
  first: BOOLEAN;
  enoff, ensize: LONGINT;
  last: LONGINT;		(*static local for ClearStack: last offset touched*)

  PROCEDURE ClearStack(off, size: LONGINT);
  VAR
    L: LONGINT;
  BEGIN
    IF first THEN BEGIN
      OPOi386.GenTyp1 (BXOR, RegReg, EAX, EAX, noInx, noScale, noDisp, noImm);
      first := FALSE;
      last := 0;
    END;
    WHILE last - off-size > 4096 DO BEGIN
      DEC(last, 4096);
      OPOi386.GenMOV (RegMem, EAX, EBP, noInx, noScale, last, noImm);
    END;
    last := off;
    IF size <= 5*4 THEN BEGIN
      WHILE size >= 4 DO BEGIN
        DEC(size, 4);
        OPOi386.GenMOV (RegMem, EAX, EBP, noInx, noScale, off+size, noImm);	(*offsets are negative, reverse traversal*)
      END
    END ELSE BEGIN
      OPOi386.GenMOV (ImmReg, ECX, noBase, noInx, noScale, noDisp, _SYSTEM._DIV(size,4));
      OPOi386.GenLEA (EBX, EBP, noInx, noScale, off);
      L := OPOi386.pcc;
      OPOi386.GenDEC (ImmReg, ECX, noBase, noInx, noScale, noDisp);
      OPOi386.GenMOV (RegMem, EAX, EBX, ECX, Scale4, noDisp, noImm);
      OPOi386.GenJcc (JNZ, L - (OPOi386.pcc + 2))
    END
  END;
		
  PROCEDURE TraverseLocals(offset: LONGINT; obj: OPT.Objects);
  VAR
    size, adr, oldoff, oldsize: LONGINT; t: OPT.Structs;
			
    PROCEDURE TraverseRecord(offset: LONGINT; t: OPT.Structs);
    BEGIN
      IF t.BaseTyp <> NIL THEN
        TraverseRecord(offset, t.BaseTyp);
      TraverseLocals(offset, t.link)
    END;

  BEGIN
    WHILE obj <> NIL DO BEGIN
      WHILE (obj<>NIL) AND NOT(obj.mode IN [omVar, omFld]) DO obj := obj.link;
      IF obj <> NIL THEN BEGIN
        IF obj.mode = omFld THEN	TraverseLocals(offset, obj.link);	(*rec-fields: first traverse the rest of list*)
        t := obj.typ;
        size := 0;
        IF obj.mode = omVar THEN  adr := obj.linkadr  ELSE adr := offset+obj.adr;
        IF (t.form = sfPointer) OR (t.form = sfProcTyp) OR (obj.name = OPT.HdPtrName) THEN
          size := 4
        ELSE IF t.comp = csRecord THEN BEGIN
          WHILE t <> NIL DO BEGIN
            TraverseLocals(adr, t.link);
            t := t.BaseTyp
          END;
          size := 0
        END ELSE IF t.comp = csStaticArr THEN BEGIN
          WHILE t.comp = csStaticArr DO  t := t.BaseTyp;
          IF (t.form = sfPointer) OR (t.form = sfProcTyp) THEN
            size := obj.typ.size
          ELSE IF t.comp = csRecord THEN BEGIN
            oldoff := enoff;
            oldsize := ensize;
            enoff := 0;
            ensize := 0;
            TraverseLocals(10000, t.link);
            IF ensize <> 0 THEN	size := obj.typ.size;
            enoff := oldoff;
            ensize := oldsize;
          END
        END;
        INC(size, _SYSTEM._MOD(-size,4));		(* round-up*)
        IF size = 0 THEN	(*no pointers*)
        ELSE IF (offset <= 0) AND (enoff <> adr+size) THEN BEGIN	(*new entry*)
          IF ensize <> 0 THEN ClearStack(enoff, ensize);
          enoff := adr;
          ensize := size;
        END ELSE BEGIN
          INC(ensize, size);
          enoff := adr;
        END;
        IF obj.mode = omVar THEN obj := obj.link ELSE obj := NIL;		(*vars: traverse the rest of the list, list tail-recursion*)
      END;
    END;
  END;
		
  PROCEDURE FullClearStack(size: INTEGER);		(*size in doublewords*)
  VAR
    i: LONGINT;
  BEGIN
    ASSERT(size > 0{, 100});
    IF size < 8 THEN BEGIN
      OPOi386.GenTyp1 (BXOR, RegReg, EAX, EAX, noInx, noScale, noDisp, noImm);
      WHILE size > 0 DO BEGIN
        OPOi386.GenPUSH(Regs, EAX, noBase, noInx, noScale, noDisp, noImm);
        DEC(size);
      END;
    END ELSE BEGIN
      OPOi386.GenMOV(ImmReg, ECX, noBase, noInx, noScale, noDisp, _SYSTEM._DIV(size,4));
      OPOi386.GenTyp1 (BXOR, RegReg, EAX, EAX, noInx, noScale, noDisp, noImm);
      i := _SYSTEM._MOD(size,4);
      WHILE i > 0 DO BEGIN
        OPOi386.GenPUSH(Regs, EAX, noBase, noInx, noScale, noDisp, noImm);
        DEC(i);
      END;
      OPOi386.GenDEC(Imme, ECX, noBase, noInx, noScale, noDisp);
      OPOi386.GenPUSH(Regs, EAX, noBase, noInx, noScale, noDisp, noImm);
      OPOi386.GenPUSH(Regs, EAX, noBase, noInx, noScale, noDisp, noImm);
      OPOi386.GenPUSH(Regs, EAX, noBase, noInx, noScale, noDisp, noImm);
      OPOi386.GenPUSH(Regs, EAX, noBase, noInx, noScale, noDisp, noImm);
      OPOi386.GenJcc(JNZ, -7)
    END;
  END;

BEGIN
  ASSERT (locSize MOD 4 = 0);
  OPOi386.GenPUSH (Regs, EBP, noBase, noInx, noScale, noDisp, noImm);
  OPOi386.GenMOV (RegReg, EBP, ESP, noInx, noScale, noDisp, noImm);
  IF (locSize <> 0) THEN BEGIN
    IF (OPM.ptrinit IN OPM.options) THEN BEGIN
      first := TRUE;
      IF (OPM.fullstackinit IN OPM.options) THEN BEGIN
        FullClearStack(_SYSTEM._DIV(locSize,4))
      END ELSE BEGIN
        OPOi386.GenTyp1 (BSUB, ImmReg, ESP, noBase, noInx, noScale, noDisp, locSize);
        enoff := 0;
        ensize := 0;
        TraverseLocals(0, locals);
        IF ensize <> 0 THEN ClearStack(enoff, ensize);
        ClearStack(-locSize, 0);		(*force touch of the whole remaining stack*)
      END
    END ELSE BEGIN
      OPOi386.GenTyp1 (BSUB, ImmReg, ESP, noBase, noInx, noScale, noDisp, locSize);
      ClearStack(-locSize, 0)		(*force touch of the whole remaining stack*)
    END
  END;
  IF (sysflag = stdcall) OR (sysflag = cdecl) THEN BEGIN
    OPOi386.GenPUSH (Regs, EBX, noBase, noInx, noScale, noDisp, noImm);
    OPOi386.GenPUSH (Regs, ESI, noBase, noInx, noScale, noDisp, noImm);
    OPOi386.GenPUSH (Regs, EDI, noBase, noInx, noScale, noDisp, noImm)
  END
END;

PROCEDURE GenLeave (sysflag: SHORTINT); (* ejz *)
BEGIN
  IF (sysflag = stdcall) OR (sysflag = cdecl) THEN BEGIN
    OPOi386.GenPOP (Regs, EDI, noBase, noInx, noScale, noDisp);
    OPOi386.GenPOP (Regs, ESI, noBase, noInx, noScale, noDisp);
    OPOi386.GenPOP (Regs, EBX, noBase, noInx, noScale, noDisp)
  END;
  OPOi386.GenMOV (RegReg, ESP, EBP, noInx, noScale, noDisp, noImm);
  OPOi386.GenPOP (Regs, EBP, noBase, noInx, noScale, noDisp)
END;

PROCEDURE PushRegs;
  VAR i: SHORTINT; disp: LONGINT;
BEGIN
  IF nofSavedLevel > MaxSaveLevel THEN OPM.err (251)
  ELSE BEGIN
    i := 0;
    WHILE i < 8 DO BEGIN
      savedRegs [nofSavedLevel].sreg [i] := sregTab [i];
      savedRegs [nofSavedLevel].reg [i] := regTab [i];
      IF (regTab [i] <> free) AND NOT(i IN [ESP, EBP]) THEN BEGIN
        OPOi386.GenPUSH (Regs, i, noBase, noInx, noScale, noDisp, noImm);
        regTab [i] := free
      END;
      INC (i)
    END;
    disp := 0; i := 0;
    WHILE i < 8 DO BEGIN
      IF fregTab [i] <> free THEN INC (disp, 8);
      INC (i)
    END;
    i := 0;
    IF disp > 0 THEN BEGIN
      OPOi386.GenTyp1 (BSUB, ImmReg, ESP, noBase, noInx, noScale, noDisp, disp);
      disp := disp - 8;
      WHILE disp >= 0 DO BEGIN
        IF fregTab [ftop] <> free THEN BEGIN
          OPOi386.GenFSTP (RegMem, lRReal, ESP, noInx, noScale, disp);
          savedRegs [nofSavedLevel].freg [i] := fregTab [ftop];
          INC (i);
          fregTab [ftop] := free;
          DEC (disp, 8);
        END ELSE
          OPOi386.GenFop1(OPOi386.gfINCSTP); (* increment stack top *)
        ftop := _SYSTEM._MOD((ftop + 1),8);
      END;
      OPOi386.PutByte (BWAIT);
    END;
    WHILE i < 8 DO BEGIN
      savedRegs [nofSavedLevel].freg [i] := free;
      INC (i)
    END;
    INC (nofSavedLevel)
  END
END;
	
PROCEDURE PopRegs (VAR instr: Instruction);
VAR 
  i, j, size, freg: SHORTINT;
  disp: LONGINT;
BEGIN
  DEC (nofSavedLevel);
  IF instr.hint <> noHint THEN
    size := _SYSTEM._MOD(instr.op,8) * 8 (* procedure with result *)
  ELSE
    size := -1;
  i := 7;
  WHILE (i >= 0) AND (savedRegs [nofSavedLevel].freg[i] = free) DO DEC (i);
  IF (instr.hint = useST) AND (i >= 0) THEN BEGIN(* save result *)
    disp := 8;
    OPOi386.GenTyp1 (BSUB, ImmReg, ESP, noBase, noInx, noScale, noDisp,  8);
    OPOi386.GenFSTP (RegMem, lRReal, ESP, noInx, noScale, 0);
    OPOi386.PutByte (BWAIT);
    fregTab [ftop] := free;
    ftop := _SYSTEM._MOD((ftop + 1),8)
  END ELSE
    disp := 0;
  j := i;
  WHILE j >= 0 DO BEGIN
    GetFreg (freg);
    OPOi386.GenFLD (Mem, lRReal, ESP, noInx, noScale, disp);
    fregTab [freg] := savedRegs [nofSavedLevel].freg [j];
    InstrTab [fregTab [freg]].reg := freg;
    INC (disp, 8);
    DEC (j) 
  END;
  IF instr.hint = useST THEN BEGIN
    size := -1;
    IF i >= 0 THEN BEGIN(* load result *)
      GetFreg (freg);
      OPOi386.GenFLD (Mem, lRReal, ESP, noInx, noScale, 0);
      fregTab [freg] := instr.dest; instr.reg := freg;
    END ELSE BEGIN
      fregTab [ftop] := instr.dest;
      instr.reg := ftop (* result already on the stack *)
    END
  END;
  IF disp > 0 THEN
    OPOi386.GenTyp1 (BADD, ImmReg, ESP, noBase, noInx, noScale, noDisp, disp);
  IF size = Bit8 THEN BEGIN
    regTab[EAX] := Splitted;
    sregTab [0] := instr.dest; sregTab [4] := free;
    instr.reg := EAX + size
  END ELSE IF (size = Bit16) OR (size = Bit32) THEN BEGIN
    regTab[EAX] := instr.dest;
    instr.reg := EAX + size (* result in EAX, AX, AL *)
  END ELSE IF (size = Bit64) THEN BEGIN
    regTab[EAX] := instr.dest;
    regTab[EDX] := instr.src1;
    instr.reg := EAX;
    InstrTab[instr.src1].reg := EDX
  END;
		
  i := EDI;
  WHILE i >= EAX DO BEGIN
    IF (savedRegs [nofSavedLevel].reg[i] = free) THEN
      (* nothing to do *)
    ELSE IF (i IN [ESP, EBP]) THEN BEGIN
      sregTab [i] := savedRegs [nofSavedLevel].sreg[i];	(* restore only *)
      regTab [i] := savedRegs [nofSavedLevel].reg [i];
    END ELSE IF regTab [i] = free THEN BEGIN
      sregTab [i] := savedRegs [nofSavedLevel].sreg[i];	(* restore *)
      regTab [i] := savedRegs [nofSavedLevel].reg [i];
      OPOi386.GenPOP (Regs, i, noBase, noInx, noScale, noDisp)
    END ELSE BEGIN		(* troubles, already in use *)
      (* find free register *)
      j := EBX; WHILE (j > i) AND (regTab[j] <> free) DO DEC(j);
      IF j = i THEN BEGIN
        j := EBX;
        WHILE (j > i) AND (regTab[j] <> Splitted) DO DEC(j);
        IF j = i THEN BEGIN
          OPM.err (215);
          RegErr := TRUE;
          EXIT;
        END
      END;
      GetThisReg(j);
      OPOi386.GenPOP(Regs, j, noBase, noInx, noScale, noDisp);
      sregTab[j] := savedRegs[nofSavedLevel].sreg[i];
      regTab[j] := savedRegs [nofSavedLevel].reg[i];
				
      IF regTab[j] = Splitted THEN BEGIN
        IF sregTab[j] >= 0 THEN InstrTab[sregTab[j]].reg := j + AL;
        IF sregTab[j+4] >= 0 THEN InstrTab[sregTab [j+4]].reg := j+4 + AL;
      END ELSE IF (_SYSTEM._MOD(InstrTab[regTab[j]].op,8) = 1) THEN	(*size = Bit16*)
        InstrTab[regTab[j]].reg := j+AX
      ELSE
        InstrTab[regTab[j]].reg := j;
    END;
    DEC(i)
  END;
END;

PROCEDURE FixupCaseTab (VAR instr: Instruction);
VAR
  elseLabel, from, Vto, val, caseFixup: LONGINT;
BEGIN
  caseFixup := link [0].offset;
  elseLabel := InstrTab [instr.src2].pc;
  from := instr.src1;
  Vto := instr.src1 + instr.inx - 4; (* instr.inx = length *)
  WHILE from <= Vto DO BEGIN
    OPOi386.GetConsDWord (from, val);
    IF val = aNil THEN
      val := elseLabel
    ELSE
      val := InstrTab [val].pc;
    IF from = Vto THEN BEGIN (* last case table entry *)
      IF caseFixup >= 32768 THEN
        val := (caseFixup - $10000) * $10000 + val
      ELSE
        val := caseFixup * $10000 + val;
    END ELSE BEGIN
      IF from + 4 >= 32768 THEN
        val := (from + 4 - $10000) * $10000 + val
      ELSE
        val := (from + 4) * $10000 + val;
    END;
    OPOi386.PutConsDWord (from, val);
    from := from + 4
  END;
  link [0].offset := instr.src1;
END;

PROCEDURE GenEntier (VAR instr: Instruction);
VAR
  dest, src, reg, dummy: SHORTINT;
BEGIN
  FindFreg (instr.src1, src);
  dummy := none;
  AssignReg (instr.dest, dummy, dummy, dummy);
  dest := instr.reg;
  ASSERT (dest  IN [EAX..EDI]);
  OPOi386.GenTyp1 (BSUB, ImmReg, ESP, noBase, noInx, noScale, noDisp, 8);
  OPOi386.GenFSTCW (ESP, noInx, noScale, 0);
  OPOi386.PutByte (BWAIT);
  OPOi386.GenMOV (MemReg, dest, ESP, noInx, noScale, 0, noImm);
  (*OPOi386.GenTyp1 (OPOi386.AND, ImmReg, dest, noBase, noInx, noScale, noDisp, 0F3FFH);*)	(*prk removed*)
  OPOi386.GenTyp1 (BOr, ImmReg, dest, noBase, noInx, noScale, noDisp, $0400);
  OPOi386.GenMOV (RegMem, dest, ESP, noInx, noScale, 4, noImm);
  OPOi386.GenFLDCW (ESP, noInx, noScale, 4);
  IF NOT LastUseF (src) THEN BEGIN
    IF src <> ftop THEN BEGIN(* can only store ftop *)
      GetFreg (reg);
      OPOi386.GenFLD (Regs, reg, src, noInx, noScale, noDisp);
      OPOi386.GenFSTP (RegMem, OPOi386.sIInt, ESP, noInx, noScale, 4);
      ReleaseFreg (reg)
    END ELSE
      OPOi386.GenFST (RegMem, OPOi386.sIInt, ESP, noInx, noScale, 4);
  END ELSE
    OPOi386.GenFSTP (RegMem, OPOi386.sIInt, ESP, noInx, noScale, 4);
  OPOi386.PutByte (BWAIT);
  OPOi386.GenFLDCW (ESP, noInx, noScale, 0);
  OPOi386.GenMOV (MemReg, dest, ESP, noInx, noScale, 4, noImm);
  OPOi386.GenTyp1 (BADD, ImmReg, ESP, noBase, noInx, noScale, noDisp, 8);
  DecCheckFreg (src)
END;

PROCEDURE OPLFload (VAR instr: Instruction);
VAR
  mode, scale, size, base, inx: SHORTINT;
  disp: LONGINT;
BEGIN
  FindMemReg (instr, mode, scale, size, base, inx, disp);
  size := (_SYSTEM._DIV(size,8)-3)*2;
  ASSERT (mode <> RegReg);
  AssignFreg (instr.dest);
  IF instr.op DIV 32 = sFild THEN
    OPOi386.GenFLD (mode, OPOi386.sIInt, base, inx, scale, disp)
  ELSE
    OPOi386.GenFLD (mode, size, base, inx, scale, disp);
  DecReg (base);
  DecReg (inx);
  IF (mode IN [RegMem, MemReg]) AND (base = noBase) AND NOT instr.abs THEN (* absolute access *)
    AbsAccess (instr.node, OPOi386.pcc - 4)
END;

PROCEDURE OPLFstore (VAR instr: Instruction);
VAR
  mode, scale, size, base, inx, src: SHORTINT;
  disp: LONGINT;
BEGIN
  FindMemReg (instr, mode, scale, size, base, inx, disp);
  size := (_SYSTEM._DIV(size,8)-3)*2;
  IF instr.op DIV 32 = sFist THEN size := sIInt;
  FindFreg (instr.dest, src);
  ASSERT (LastUseF (src) AND (src = ftop));
  OPOi386.GenFSTP (mode, size, base, inx, scale, disp);
  DecCheckFreg (src);
  DecReg (base);
  DecReg (inx);
  IF (mode IN [RegMem, MemReg]) AND (base = noBase) AND NOT instr.abs THEN (* absolute access *)
    AbsAccess (instr.node, OPOi386.pcc - 4);
  OPOi386.PutByte (BWAIT)
END;
	
PROCEDURE FloatGen1 (VAR instr: Instruction);
VAR
  src: SHORTINT;
BEGIN
  FindFreg (instr.src1, src);
  ASSERT (LastUseF (src) AND (src = ftop));
  ReleaseFreg (src);
  AssignFreg (instr.dest);
  IF instr.op DIV 32 = sFabs THEN
    OPOi386.GenFop1 (gfABS)
  ELSE BEGIN
    ASSERT (instr.op DIV 32 = sFchs);
    OPOi386.GenFop1 (gfCHS)
  END;
END;
	
PROCEDURE FloatGen3 (VAR instr: Instruction);
  VAR
    mode, size, src, src1, src2: SHORTINT;
    reverse, r2: BOOLEAN;
BEGIN
  size := (_SYSTEM._MOD(instr.op,8) -3) *2;
  FindFreg (instr.src1, src1);
  FindFreg (instr.src2, src2);
  r2 := FALSE;
  IF NOT LastUseF (src1) AND NOT LastUseF (src2) THEN BEGIN
    (* copy src1->ST *)
    OPOi386.GenFLD (Regs, size, _SYSTEM._MOD((src1 - ftop),8), noInx, noScale, noDisp);
    (* src := src2, ST := src1 *)
    src := src2;
    mode := RegSt;
    reverse := FALSE;
  END ELSE IF src1 = ftop THEN BEGIN
    reverse := TRUE;
    IF LastUseF (src1) THEN BEGIN
      IF LastUseF (src2) THEN
        mode := StRegP
      ELSE BEGIN
        mode := RegSt;
        reverse := FALSE
      END
    END ELSE
      mode := StReg;
    (* src := src2, ST := src1 *)
    src := src2;
  END ELSE IF src2 = ftop THEN BEGIN
    (* REVERSE *)
    reverse := FALSE;
    r2 := TRUE;
    IF LastUseF (src2) THEN BEGIN
      IF LastUseF (src1) THEN mode := StRegP ELSE BEGIN
        mode := RegSt;
        reverse := TRUE
      END
    END ELSE
      mode := StReg;
    (* src := src1, ST := src2 *)
    src := src1
  END ELSE BEGIN
    (* copy src1->ST *)
    OPOi386.GenFLD (Regs, size, _SYSTEM._MOD((src1 - ftop),8), noInx, noScale, noDisp);
    IF LastUseF (src1) THEN FreeFreg (src1); src1 := none;
    IF LastUseF (src2) THEN BEGIN
      mode := StRegP;
      reverse := TRUE
    END ELSE BEGIN
      mode := RegSt;
      reverse := FALSE
    END;
    (* src := src2, ST := src1 *)
    src := src2
  END;
  CASE instr.op DIV 32 OF
    sFadd: OPOi386.GenFADD (mode, size, _SYSTEM._MOD((src - ftop),8), noInx, noScale, noDisp);
    sFsub:
          IF reverse THEN
            OPOi386.GenFSUBR (mode, size, _SYSTEM._MOD((src - ftop),8), noInx, noScale, noDisp)
          ELSE
            OPOi386.GenFSUB (mode, size, _SYSTEM._MOD((src - ftop),8), noInx, noScale, noDisp);
    sFmul: OPOi386.GenFMUL (mode, size, _SYSTEM._MOD((src - ftop),8), noInx, noScale, noDisp);
    sFdiv:
          IF reverse THEN
            OPOi386.GenFDIVR (mode, size, _SYSTEM._MOD((src - ftop),8), noInx, noScale, noDisp)
          ELSE
            OPOi386.GenFDIV (mode, size, _SYSTEM._MOD((src - ftop),8), noInx, noScale, noDisp);
  ELSE HALT (BUG)
  END;
  IF r2 THEN BEGIN
    DecCheckFreg (src2);
    DecCheckFreg (src1)
  END ELSE BEGIN
    DecCheckFreg (src1);
    DecCheckFreg (src2)
  END;
  IF mode = RegSt THEN
    AssignFreg (instr.dest)
  ELSE IF (mode = StRegP) AND (_SYSTEM._MOD((src+1),8) = ftop) THEN
    AssignFreg (instr.dest)
  ELSE
    TakeFreg (instr.dest, src);
END;

PROCEDURE FloatCmp (VAR instr: Instruction);
  VAR size, src1, src2, reg: SHORTINT; stackOK: BOOLEAN;
BEGIN
  size := (_SYSTEM._MOD(instr.op,8) -3)*2;
  FindFreg (instr.src1, src1);
  FindFreg (instr.src2, src2);
  ASSERT (LastUseF (src1) AND LastUseF (src2));
  IF src1 = ftop THEN BEGIN
    IF src2 = _SYSTEM._MOD((ftop + 1),8) THEN BEGIN
      OPOi386.GenFop1 (OPOi386.gfCOMPP);
      stackOK := TRUE
    END ELSE BEGIN
      OPOi386.GenFCOMP (Regs, size, _SYSTEM._MOD((src2 - ftop),8), noInx, noScale, noDisp);
      stackOK := FALSE
    END
  END ELSE BEGIN
    stackOK := FALSE;
    GetFreg (reg);
    OPOi386.GenFLD (Regs, size, _SYSTEM._MOD((src1-ftop-1),8), noInx, noScale, noDisp);
    OPOi386.GenFCOMP (Regs, size, _SYSTEM._MOD((src2-ftop),8), noInx, noScale, noDisp);
    ReleaseFreg (reg);
  END;
  GetThisReg (EAX);
  OPOi386.GenFop1 (OPOi386.gfSTSW); (* flags into AX *)
  OPOi386.PutByte (BSAHF); (* store ah into flags *);
  IF stackOK THEN BEGIN
    DecCheckFreg (src1);
    DecCheckFreg (src2)
  END ELSE BEGIN
    DecCheckFreg (src1);
    DecCheckFreg (src2);
    OPOi386.GenFFREE (0)
  END;
  FreeReg (EAX)
END;

PROCEDURE GenPortIO (VAR instr: Instruction);					(* New Functions *)
VAR
  size: INTEGER;
  pin : BOOLEAN;
BEGIN
  size := _SYSTEM._MOD(instr.op,8) * 8;
  pin := instr.op DIV 32 = sIn;
  IF pin THEN BEGIN
    (* FindMemReg(instr, dummy, dummy, reg, dummy, dummy, ldummy); *)
    ASSERT(NOT loaded(instr.dest));
    IF size = Bit8 THEN
      AssignThisReg( instr.dest, AL)
    ELSE IF size = Bit16 THEN
      AssignThisReg( instr.dest, AX)
    ELSE IF size = Bit32 THEN
      AssignThisReg( instr.dest, EAX)
    ELSE
      HALT(BUG);
    ASSERT(loaded(instr.dest));
  END ELSE BEGIN
    ASSERT(loaded(instr.src1));
    FreeReg(InstrTab[instr.src1].reg)
  END;
  IF pin THEN OPOi386.GenIN(size) ELSE OPOi386.GenOUT(size);	(* Bug1 *)
  FreeReg( DX );
END;

PROCEDURE GenAsm ( instr: Instruction );
VAR
  n, code, fix: OPT.Nodes;
  pc: LONGINT;
BEGIN
  pc := OPOi386.pcc;
  n := instr.node;
  code := n.left;
  WHILE code <> NIL DO BEGIN
    OPOi386.InlineCode (code.conval^.code, 0);
    code := code.link;
  END;
  fix := n.right;
  WHILE fix <> NIL DO BEGIN
    IF (fix.obj.mode = omVar) AND (fix.obj.mnolev <=0) THEN BEGIN
      OPOi386.PutDWordAt(pc + fix.conval^.intval, fix.obj.linkadr);
      AbsAccess (fix, pc + fix.conval^.intval)
    END ELSE IF (fix.obj.linkadr <= MAX(_SHORTINTS)) AND (fix.obj.linkadr >= MIN(_SHORTINTS)) THEN
      OPOi386.PutByteAt(pc + fix.conval^.intval, fix.obj.linkadr)
    ELSE
      OPM.Mark(600,fix.conval^.errpos);
    fix := fix.link
  END
END;

PROCEDURE ClearSDynArr(VAR instr: Instruction);
VAR
  L: LONGINT;
  reg: SHORTINT;
BEGIN
  FindReg(instr.src1, reg);
  OPOi386.GenTyp1 (BXOR, RegReg, EAX, EAX, noInx, noScale, noDisp, noImm);
  L := OPOi386.pcc;
  OPOi386.GenPUSH (Regs, EAX, noBase, noInx, noScale, noDisp, noInx);
  OPOi386.GenDEC (ImmReg, reg, noBase, noInx, noScale, noDisp);
  OPOi386.GenJcc (JNZ, L - (OPOi386.pcc + 2));
  FreeReg(reg);
END;

PROCEDURE Load (VAR instr: Instruction);
VAR
  mode, scale, size, base, inx, dummy: SHORTINT;
  disp: LONGINT;
			
  PROCEDURE AssignReg (pReg: LONGINT; VAR baseReg, inxReg: SHORTINT);
  VAR
    hint, size, pRegBase, pRegInx: LONGINT;
    base, inx, op: SHORTINT;  (* NM 7.6.94; workaround for sign-extended bug *)
  BEGIN
    pRegBase:=0;
    pRegInx:=0;
    hint := InstrTab[pReg].hint;
    size:= _SYSTEM._MOD(InstrTab[pReg].op ,8) * 8;
    IF hint >= tryEAX THEN BEGIN
      IF size = Bit8 THEN BEGIN
        IF (sregTab [hint - tryEAX] = free) AND (regTab [hint - tryEAX] = free) THEN BEGIN
          AssignThisReg (pReg, hint-tryEAX+Bit8);
          EXIT;
        END
      END ELSE IF regTab [hint - tryEAX] = free THEN BEGIN
        AssignThisReg (pReg,hint - tryEAX + size);
        EXIT;
      END;
      hint:= noHint
    END;
    base:= baseReg;
    inx:= inxReg;
    IF hint <= noHint THEN BEGIN
      op := instr.op DIV 32;
      IF (op = sLdbdw) OR (op = sLdbw) OR (op = sLdwdw) OR (op = sLdbdwu) OR
        (op = sLdbwu) OR (op = sLdwdwu) THEN
        AssignNewReg (pReg)
      ELSE IF (base = none) OR (base IN [ESP, EBP]) OR NOT LastUse (base) OR
        ((size = Bit8) AND (base IN [EDI, ESI, ESP, EBP, DI, SI, SP, BP])) THEN BEGIN(* base can't be reused *)
          IF (inx = none) OR (inx IN [ESP, EBP]) OR NOT LastUse (inx) OR
          ((size = Bit8) AND (inx IN [EDI, ESI, ESP, EBP, DI, SI, SP, BP])) THEN
          (* inx can't be reused *)
            AssignNewReg (pReg)
          ELSE
            InstrTab[pReg].reg := _SYSTEM._MOD(inx,8) + size;
      END ELSE
        InstrTab[pReg].reg := _SYSTEM._MOD(base,8) + size;
    END ELSE BEGIN
      IF inx >= AL THEN
        pRegInx := sregTab [inx - AL]
      ELSE IF inx <> noInx THEN
        pRegInx := regTab [_SYSTEM._MOD(inx,8)];
      IF base >= AL THEN
        pRegBase := sregTab [base - AL]
      ELSE IF base <> noBase THEN
        pRegBase := regTab [_SYSTEM._MOD(base,8)];
      AssignThisReg (pReg,hint + size);
      IF (inx <> none) AND (pRegInx >= 0) THEN inxReg := InstrTab [pRegInx].reg;
      IF (base <> none) AND (pRegBase >= 0) THEN baseReg := InstrTab [pRegBase].reg;
    END
  END;

BEGIN
  disp:=0;
  scale:=0;
  FindMemReg (instr, mode, scale, size, base, inx, disp);
  ASSERT ((size = Bit8) OR (size = Bit16) OR (size = Bit32));
  IF instr.op DIV 32 <> sPUTreg THEN AssignReg (instr.dest, base, inx);
  CASE instr.op DIV 32 OF
    sLd:
          BEGIN
            ASSERT ((mode <> RegReg) OR ((mode = RegReg) AND (instr.reg <> base)));
            OPOi386.GenMOV (mode, instr.reg, base, inx, scale, disp, instr.src2);
          END;
    sLea:
          BEGIN
            ASSERT ((mode <> RegReg) OR ((mode = RegReg) AND (instr.reg <> base)));
            OPOi386.GenLEA (instr.reg, base, inx, scale, disp);
          END;
    sLdbdw, sLdbw   : OPOi386.GenMOVSX (mode, 0, instr.reg, base, inx, scale, disp);
    sLdwdw          : OPOi386.GenMOVSX (mode, 1, instr.reg, base, inx, scale, disp);
    sLdbdwu, sLdbwu : OPOi386.GenMOVZX (mode, 0, instr.reg, base, inx, scale, disp);
    sLdwdwu         : OPOi386.GenMOVZX (mode, 1, instr.reg, base, inx, scale, disp);
    sPUTreg         : OPOi386.GenMOV (mode, instr.hint + size, base, inx, scale, disp, instr.src2);
  ELSE
    HALT (BUG)
  END;
  dummy:=  none;
  DecCheckReg (instr.dest, dummy, base, inx);
  IF (mode IN [RegMem, MemReg]) AND (base = noBase) AND NOT instr.abs THEN (* absolute *)		(* GetPut *)
    AbsAccess (instr.node, OPOi386.pcc - 4);
END;

//####################################################################

PROCEDURE GenCode (pSize: INTEGER);
VAR
  obj, list: OPT.Objects;
  i, k: LONGINT;
  op, reg, ret, sysflag: SHORTINT;
  node: OPT.Nodes;
			
  PROCEDURE MarkPos;
  VAR
    j : LONGINT;
  BEGIN
    IF mapSize < LENGTH(vmap^) THEN BEGIN
      vmap^[mapSize].pos := InstrTab[i].src1;
      vmap^[mapSize].pc := OPOi386.pcc;
      j := mapSize-1;
      WHILE (j>= 0) AND (vmap^[j].pos < 0) DO BEGIN
        vmap^[j].pos := vmap^[mapSize].pos;
        DEC(j)
      END;
      INC(mapSize)
    END ELSE BEGIN
      vmap^[mapSize-1].pos := -1;
      vmap^[mapSize-1].pc := -1
    END;
  END;

BEGIN
  ftop := 7;
  FreeRegDisp := 0;
  sysflag:=0;
  i := 0;
  WHILE i < nofTrapFixups DO BEGIN
    trapFixupTab[i] := aNil;
    INC (i)
  END;
  i := 0;
  WHILE i < 8 DO BEGIN
    regTab [i] := free;
    sregTab [i] := free;
    fregTab [i] := free;
    INC (i)
  END;
  regTab [ESP] := Occupied;
  regTab [EBP] := Occupied; (* stack and base pointer are always used *)
  RegErr := FALSE;
  i := 0;
  WHILE NOT OPOi386.CodeErr AND NOT RegErr AND (i < pSize) DO BEGIN
    node := InstrTab [i].node;
    FixupJcc (InstrTab [i].pc);
    InstrTab [i].pc := OPOi386.pcc;
    op := InstrTab [i].op DIV 32;

    IF op > 0 THEN BEGIN(* no dead code *)  
        (*
				OPM.LogWLn; OPM.LogWNum(i, 3); OPM.LogWNum(op, 4);
				OPM.LogWNum(InstrTab[i].op MOD 8, 2);
				OPM.LogWNum(InstrTab[i].op DIV 8 MOD 4, 2);
				OPM.LogWNum(InstrTab[i].dest, 4);
				OPM.LogWNum(InstrTab[i].src1, 4);
				OPM.LogWNum(InstrTab[i].src2, 4);
				OPM.LogWNum(InstrTab[i].inx,  4);
				OPM.LogWNum(InstrTab[i].hint, 4);
        OPM.LogW(' '); OPM.LogWHex(InstrTab[i].pc+$49);
        OPM.LogWNum(InstrTab[i].pc,   4);
        OPM.LogWNum(InstrTab[i].op,   8);
        OPM.LogWNum(InstrTab[i].used, 3);
        OPM.LogWNum(InstrTab[i].scale, 3);
        *)
      CASE op OF
        sNewStat:
                  BEGIN
                    OPM.errpos.CodePos := InstrTab [i].src1;
                    IF vmap <> NIL THEN MarkPos;
                  END;
        sLd, sLea, sLdbdw, sLdwdw, sLdbw,
        sLdbdwu, sLdwdwu, sLdbwu, sPUTreg : OPLi386.Load(InstrTab[i]);
        sLdProc, sLdXProc                 : LoadProc (InstrTab[i]);
        sSto, sGETreg                     : OPLStore (InstrTab[i]);
        sPush                             : GenPush (InstrTab[i]);
        sPop                              : GenPop (InstrTab [i]);
        sAdd, sSub, soR..sRol             : Gen3 (InstrTab [i]);
        sDiv, sMod                        : GenDivMod (InstrTab [i]);
        sMul                              : GenMul (InstrTab [i]);
        sNeg, sNot                        : Gen2 (InstrTab [i]);
        sAbso                             : GenAbs (InstrTab [i]);
        sCmp, sBt, sTest                  : Flags (InstrTab [i]);
        sSete..sSetnc                     : Setcc (InstrTab [i]);
        sJe..sJmpReg                      : Gen1 (InstrTab [i], i);
        sTe..sTa, sTo, sTae, sTle         : GenTrapCC (InstrTab [i]);
        sTrap                             : GenTrap (InstrTab[i].src2);
        sCall:
                  BEGIN
                    node := InstrTab [i].node;
                    obj := node.left.obj;
                    IF obj.mode = omCProc THEN
                      HALT(99)
                    ELSE IF InstrTab [i].src2 >= 0 THEN
                      OPOi386.GenCALL (Imme, none, noBase, noInx, noScale, InstrTab [i].src2 - (OPOi386.pcc+5))
                    ELSE BEGIN
                      OPOi386.GenCALL (Imme, none, noBase, noInx, noScale, InstrTab [i].src2);
                      IF -2 - node.left.obj.linkadr = i THEN EncodeFixup (i);
                    END
                  END;
        sXcall:
                  BEGIN
                    OPOi386.GenCALL (Imme, none, noBase, noInx, noScale, 0);
                    AddLink (_SYSTEM._DIV(InstrTab [i].src2,$10000), InstrTab [i].pc + 1)
                  END;
        sCallReg: (* !!later optimize *)
                  BEGIN
                    FindReg (InstrTab [i].src2, reg);
                    OPOi386.GenCALL (Regs, reg, noBase, noInx, noScale, noDisp);
                    DecReg (reg)
                  END;
        sEnter:
                  BEGIN
                    IF vmap <> NIL THEN MarkPos;
                    IF node <> NIL THEN BEGIN
                      list := node.obj.scope.scope;
                      sysflag := node.obj.sysflag
                    END ELSE BEGIN
                      list := NIL;
                      sysflag := 0
                    END;
                    GenEnter(InstrTab[i].src2, list, sysflag);
                  END;
        sLeave:   GenLeave(sysflag);
        sRet:
                  BEGIN
                    k := EAX;
                    ret := -1;
                    WHILE k <= EDI DO BEGIN
                      IF NOT(k IN [ESP, EBP]) AND (regTab [k] <> free) THEN BEGIN
                        IF ret = -1 THEN ret := k
                        ELSE IF (ret = EAX) AND (k = EDX) THEN  FreeReg(EDX)		(* 8Byte, special *)
                        ELSE OPM.err (200);
                      END;
                      INC (k)
                    END;
                    IF ret <> -1 THEN BEGIN(* copy from ret to AX, free ret *)
                      IF (regTab [ret] = Splitted) AND (sregTab [ret+4] <> free) THEN (* using AH/BH/CH/DH *)
                        OPOi386.GenMOV(RegReg, AL, AH+ret, noInx, noScale, noDisp, noImm)
                      ELSE IF ret <> EAX THEN
                        OPOi386.GenMOV(RegReg, EAX, ret, noInx, noScale, noDisp, noImm);
                      IF regTab[ret] = Splitted THEN BEGIN
                        FreeReg (ret + Bit8);
                        FreeReg (ret + Bit8 + 4)
                      END ELSE IF regTab [ret] <> free THEN
                        FreeReg (ret);
                    END;
                    IF fregTab [ftop] <> free THEN FreeFreg (ftop);
                    k := 0;
                    WHILE k < 8 DO BEGIN
                      IF fregTab[k] <> free THEN OPM.err (-1001);
                        (* OPM.LogWStr ("  "); OPM.LogWNum (k, 6); OPM.LogWNum (fregTab [k], 8) *)
                      INC (k)
                    END;
                    IF FreeRegDisp <> 0 THEN BEGIN
                      //OPM.LogWLn;
                      //OPM.LogWStr ("Error FreeReg");
                      //OPM.LogWLn
                    END;
                    IF sysflag = cdecl THEN
                      OPOi386.GenRET (0)
                    ELSE
                      OPOi386.GenRET (InstrTab [i].src2);
                  END;
        sRepMovs: GenRepMovs (InstrTab [i]);
        sCmpString: GenCmpString (InstrTab [i]);
        sCld: OPOi386.PutByte (BCLD);
        sStd: OPOi386.PutByte(BSTD);
        sPushReg: PushRegs;
        sPopReg: PopRegs (InstrTab [i]);
        sCase: FixupCaseTab (InstrTab [i]);
        sPhi: GenPhi (InstrTab [i]);
        sShort: GenShort (InstrTab [i]);
        sEntier: GenEntier (InstrTab [i]);
        sLabel: (* only used for jumps *) ;
        sFLoad, sFild: OPLFload (InstrTab [i]);
        sFStore, sFist: OPLFstore (InstrTab [i]);
        sFabs, sFchs: FloatGen1 (InstrTab [i]);
        sFadd, sFsub, sFmul, sFdiv: FloatGen3 (InstrTab [i]);
        sFcmp: FloatCmp (InstrTab [i]);
        sCli: OPOi386.PutByte(BCLI);
        sSti: OPOi386.PutByte(BSTI);
        sIn, sOut: GenPortIO(InstrTab [i]);
        sAssembler: GenAsm(InstrTab[i]);
        sClear: ClearSDynArr(InstrTab[i]);
      ELSE
        HALT (BUG)
      END
    END;
    INC (i)
  END;
  FixupAndGenTrap (* fixups traps and generate code for them *)
END;

//######################################################################

PROCEDURE Close;
BEGIN
  SETLENGTH(varConsLink, 0);
  SETLENGTH(ptrTab, 0);
  SETLENGTH(varConsTab, 0);
  SETLENGTH(explist, 0);
END;

PROCEDURE OPLBegin;
BEGIN
  SETLENGTH(varConsLink, 100);
  SETLENGTH(ptrTab, 512);
  SETLENGTH(varConsTab, 500);
  SETLENGTH(explist, 32);

  JmpConvert [0] := JE;
  JmpConvert [1] := JNE;
  JmpConvert [2] := JL;
  JmpConvert [3] := JLE;
  JmpConvert [4] := JG;
	JmpConvert [5] := JGE;
  JmpConvert [6] := JA;
  JmpConvert [7] := JAE;
  JmpConvert [8] := JB;
  JmpConvert [9] := JBE;
	JmpConvert [10] := JC;
  JmpConvert [11] := JNC;

	SetccConvert [0] := gSETE;
  SetccConvert [1] := gSETNE;
  SetccConvert [2] := gSETL;
  SetccConvert [3] := gSETLE;
	SetccConvert [4] := gSETG;
  SetccConvert [5] := gSETGE;
  SetccConvert [6] := gSETA;
  SetccConvert [7] := gSETAE;
	SetccConvert [8] := gSETB;
  SetccConvert [9] := gSETBE;
  SetccConvert [10] := gSETB;
  SetccConvert [11] := gSETNB;

END;

END.
